unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  ExtCtrls, Menus, ShellApi, Types, Math,
  IpExport, IpHlpApi, IpTypes, IpIfConst, IpRtrMib,
  IniFiles2, Util;


const VersionInfo = '--- TrafMon v1.5 --- 9. may 2017 ---';


const WM_TASKABAREVENT = WM_USER+1; //Taskbar message
procedure SetWinStyle(var style:ULONG; WS_X: ULONG; bOn: boolean);

type
  TForm1 = class(TForm)
    displaypopup: TPopupMenu;
    mOptions: TMenuItem;
    xy1: TMenuItem;
    mClose: TMenuItem;
    Timer1: TTimer;
    mResetGraph: TMenuItem;
    mHide: TMenuItem;
    clicktimer: TTimer;
    mIgnoreMouse: TMenuItem;
    N1: TMenuItem;
    rafMon101: TMenuItem;
    N2: TMenuItem;
    mSmoothPeaks: TMenuItem;
    mAlwaysonTop: TMenuItem;
    HideTitleBorder1: TMenuItem;
    N3: TMenuItem;
    mHideonMouseOver: TMenuItem;
    TimerWindow: TTimer;
    Memo1: TMemo;
    TimerCounter: TTimer;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormPaint(Sender: TObject);

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    (**)
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    (**)
    procedure WMQueryEndSession(var Msg: TWMQueryEndSession);
    message WM_QUERYENDSESSION;
    procedure WMEndSession(var Msg: TWMEndSession);
    message WM_ENDSESSION;

    procedure ScrDblClick(Sender: TObject);

    procedure Timer1Timer(Sender: TObject);
    procedure clicktimerTimer(Sender: TObject);
    procedure TimerWindowTimer(Sender: TObject);

    procedure mOptionsClick(Sender: TObject);
    procedure mCloseClick(Sender: TObject);
    procedure mResetGraphClick(Sender: TObject);
    procedure mHideClick(Sender: TObject);
    procedure mIgnoreMouseClick(Sender: TObject);
    procedure mPeakClick(Sender: TObject);
    procedure mSmoothPeaksClick(Sender: TObject);
    procedure mAlwaysonTopClick(Sender: TObject);
    procedure rafMon101Click(Sender: TObject);
    procedure HideTitleBorder1Click(Sender: TObject);
    procedure mHideonMouseOverClick(Sender: TObject);
    procedure displaypopupPopup(Sender: TObject);
    procedure xy1Click(Sender: TObject);
    procedure TimerCounterTimer(Sender: TObject);

  private
    NotifyIconData: TNotifyIconData;

    procedure CreateTrayIcon;
    procedure TaskbarEvent(var Msg: TMessage); Message WM_TASKABAREVENT;
    procedure DrawBMasIcon(bm: TBitmap; transparent: Boolean; tip: string);

    procedure zwinker(i: integer);

    procedure VerticalTextOut(C: TCanvas; x,y: integer; const s: string);
    procedure ShadowTextOut(C: TCanvas; Color: TColor; X, Y: Integer; s: String);

    procedure DrawUpDown(Canvas: TCanvas; x,y:integer; up:Boolean; col:TColor);
    PROCEDURE DrawLineWindows(Canvas: TCanvas; x1,y1,x2,y2,max: Integer; col: TColor);
    PROCEDURE DrawLineBresenhamShaded(Canvas: TCanvas; x1,y1,x2,y2,palidx,max: Integer; pal: array of TColor);
    PROCEDURE DrawLineBresenham(Canvas: TCanvas; x1,y1,x2,y2,max: Integer; col: TColor);
    //PROCEDURE DrawLineNormal(Canvas: TCanvas; x1,y1,x2,y2,max: Integer; col: TColor);
    PROCEDURE DrawShadedRectangle(Canvas: TCanvas; x1, y1, x2, y2,palidx,max: Integer; pal: array of TColor);

    procedure logappend(s:string);
    procedure GetSeparatedAreaVars(var outtype, outfontsize, outheight: integer);
    procedure SetTextByIndex(outtype: integer; var sDL, sUL: string);

  public
    bdrawn, bdrawing, updating, showoptions: Boolean;
    ColDL, ColUL, ColDLAvg, ColULAvg, ColBG, ColBorder, ColGrid, ColFont, ColComb, ColShadow, ColSeparate: TColor;
    bDL, bDLAvg, bUL, bULAvg, bBold, bBG, bValuesInColor,
    bShadow, bClickThrough, bOnTop, bHideOnMouseOver,
    bHideCaption, bHideBorder, bShowInaltTab, bShowInTaskbar,
    bFilledGraph, bAverage, bScaleEqually, bSeparate, bGridunits: Boolean;
    iBorderLines, iFancyState, iFontState: integer;
    lastInOct, lastOutOct   : Cardinal;
    avg_value               : integer;
    tpCount, gridunit       : Integer;
    AdapterItemIndex        : Integer;
    drawmode, ShadowMode    : integer;
    LevelWidth, PixelWidth, FontSize   : Integer;
    FontBold                : Boolean;
    SpeedCounter            : Longint;

    WSessDL, WSessUL   : Cardinal;
    WSessDLCurr, WSessULCurr: Cardinal;
    SessDL, SessUL     : Cardinal;
    TotDL, TotUL       : Cardinal;

    Display                 : TBitmap;
    FontName: String;
    LinkedWindow: string;

    globalh: THandle;
    globalx,globaly,globalcx,globalcy:integer;
    globalrt:TRect;

    procedure config_read;
    procedure config_write;
    procedure ToggleHide;

    function  Darker(Color: TColor; val, max: Integer): TColor;
    function  Lighter(color    : TColor; val, max: Integer): TColor; overload;
    function  Lighter(col1,col2: TColor; val, max: Integer): TColor; overload;
    procedure MakeShadedPalette(var pal: array of TColor; Color: TColor; max: integer);

    procedure MakeShadedPalettes;
    procedure SetFormStyle;
    procedure SetFormStyleExternal;

    procedure varinfo(y:integer; info:string);

    procedure DeletePeaks;
    procedure DrawGraph;
    procedure UpdateInterfaces;
  end;

var
  Form1: TForm1;

  ini_file: string;

  CanvasToDraw       : TCanvas;
  bm                 : TBitmap;

  palUpload, palDownload, palCombined: array of TColor;

  size: integer;
  globalx: integer = 0;
  globalz : integer = 0;
  globaln: integer = 0;

  MaxWidth: Integer;
  barheight: integer;
  barwidth: integer;
  px,py: integer; // for moving the window
  //up: array[0..55] of integer;
  //down: array[0..55] of integer;

  SeparateWidth      : integer;
  timecurr, timelast : Cardinal;
  maxdownspeed, maxupspeed : Extended;
  maxspeed                 : Extended;
  rS, gS, bS         : Single;
  doubleclicked      : boolean;
  bflag              : Boolean;
  zwink              : boolean;
  bfull              : boolean;

implementation

uses properties;

{$R *.DFM}

var   CurrIfObj:  TIfObj;

procedure SetWinStyle(var style:ULONG; WS_X: ULONG; bOn: boolean);
begin
    if bOn then begin
        if (style and WS_X) <> WS_X then
            style := style OR WS_X;
    end else begin
        if (style and WS_X) = WS_X then
            style := style AND (NOT (WS_X))
    end;
end;


procedure TForm1.xy1Click(Sender: TObject);
begin
  displaypopup.tag:=0;
end;

procedure SysErrMsg(ErrCode: Integer; S: string);
var Len: Integer;
    Buffer: array[0..255] of Char;
begin
  if ErrCode=0 then exit;
  Len := FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM or
      FORMAT_MESSAGE_ARGUMENT_ARRAY, nil, ErrCode, 0, Buffer,
      SizeOf(Buffer), nil);
  while (Len > 0) and (Buffer[Len - 1] in [#0..#32, '.']) do Dec(Len);
  if buffer<>'' then
  Form1.Memo1.lines.add(S + ' - error ' +IntToStr(ErrCode) + ': ' + Buffer);
  //Application.MessageBox(PChar(S + IntToStr(ErrCode) + Chr(13) + Buffer), 'error');
end;

procedure TForm1.FormCreate(Sender: TObject);
var Owner : HWND;
outstr:string;
begin
    DoubleBuffered:=TRUE;

    barheight:=150;
    barwidth:=0;
    SpeedCounter:=0;
    bflag:=true;
    bdrawn:=false;
    bdrawing:=false;
    updating:=false;
    bSeparate:=false;
    bScaleEqually:=false;
    doubleclicked:=false;
    bValuesInColor:=false;
    zwink:=false;
    bfull:=false;
    linkedwindow:='';
    rs:=1; gs:=1; bs:=1;
    maxdownspeed:=0;
    maxupspeed:=0;
    lastInOct :=0;
    lastOutOct:=0;
    SessDL:=0;
    SessUL:=0;
    WSessDL:=0;
    WSessUL:=0;
    TotDL:=0;
    TotUL:=0;
    iFontState:=0;
    iFancyState:=0;
    SeparateWidth:=0;
    clicktimer.tag:=-1;
    //Constraints.MaxWidth:=Screen.Width;

    // memory-bitmap
    Display:=TBitmap.Create;
    // interface-object
    CurrIfObj:=TIfObj.Create;
    displaypopup.Items[0].Caption:=Application.Title;

    // tray-icon
    bm:=TBitmap.Create;
    bm.Height:=32;
    bm.Width:=32;
    bm.PixelFormat:=pf8bit; //Display.PixelFormat;

    /////////////////////////////////////////
    /////////////////////////////////////////
    CanvasToDraw:=Display.Canvas; // for real
    //CanvasToDraw:=Form1.Canvas; // for debug
    CanvasToDraw.Font.Name:=FontName;
    /////////////////////////////////////////
    /////////////////////////////////////////

    ini_file := ExpandFileName(ParamStr(0));
    ini_file := ExtractFilePath(ini_file) + ChangeFileExt(ExtractFileName(ParamStr(0)), '.ini');
    //MessageDlg(ini_file,mtInformation,mbOKCancel,0);

    config_read;
    SetFormStyle;
    //config_read;
    caption:=VersionInfo;
    Show;
    SetFormStyle;
    //ShowWindow(Application.Handle,SW_HIDE);

    MakeShadedPalettes;
    DrawGraph;
    CreateTrayIcon;

    //SpeedCounter:=1900;
    timecurr:=GetTickCount;
    timelast:=timecurr;
    showoptions:=false;
    if GetPrivateProfileInt('TrafficMonitor','ScreenX',50000,PChar(ini_file))=50000 then
    begin
      showoptions:=true;
    end;

end;

procedure TForm1.CreateTrayIcon;
var Icn : TIcon;
    i,j : integer;
begin
    Icn := TIcon.Create;
    Icn.Width := 32;
    Icn.Height := 32;

    Fillchar(NotifyIconData,Sizeof(NotifyIconData),0);
    NotifyIconData.cbSize := Sizeof(NotifyIconData);
    NotifyIconData.Wnd    := Handle;
    NotifyIconData.uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
    NotifyIconData.uCallbackMessage := WM_TASKABAREVENT;
    NotifyIconData.hIcon := Icn.Handle;
    NotifyIconData.szTip := '--- '+Versioninfo +' ---';
    Shell_NotifyIcon(NIM_ADD, @NotifyIconData);
    NotifyIconData.uFlags := NIF_ICON;

    // pre-fill icn data
    for i:=0 to 31 do for j:=0 to 31 do bm.Canvas.Pixels[i,j]:=clBlack; // ColBG;
    // update tray icn
    DrawBMasIcon(bm, false, '--- '+Versioninfo +' ---');
end;

procedure TForm1.FormResize(Sender: TObject);
begin
    Constraints.MaxWidth:=screen.Width+2;
    Constraints.MaxHeight:=screen.Height+2;
    Display.Width:=Form1.ClientWidth;
    Display.Height:=Form1.ClientHeight;
    bdrawn:=false;
    MaxWidth:=Max(Display.Width,Screen.Width);
    if (Form1.Visible) and (FormOptions<>nil) then
    begin
      MakeShadedPalettes;
      DrawGraph;
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Timer1.Enabled:=false;
    TimerWindow.Enabled:=false;
    clicktimer.Enabled:=false;

    config_write;
    Shell_NotifyIcon(NIM_DELETE, @NotifyIconData);
    bm.Destroy;
    //Action:=cafree;
end;

procedure TForm1.WMQueryEndSession(var msg: TWMQUERYENDSESSION);
var WindowsClosing:boolean;
var Action: TCloseAction;
begin
  Action:=caFree;
  msg.result:=1;
  //FormClose(nil,Action);
  close;
end;

procedure TForm1.WMEndSession(var msg: TWMENDSESSION);
begin
  msg.result:=1;
  Close;
end;

(**)
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var acClose: TCloseAction;
begin
  //config_write;
  CanClose:=false; //true;
  acClose:=caFree;
  //FormClose(sender,acClose);
end;
(**)

procedure TForm1.FormShow(Sender: TObject);
begin
   if not bdrawn then exit;
   BitBlt(Form1.Canvas.Handle,0,0,Form1.ClientWidth,Form1.ClientHeight,
          CanvasToDraw.Handle,0,0,SRCCOPY);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
   if not bdrawn then exit;
   BitBlt(Form1.Canvas.Handle,0,0,Form1.ClientWidth,Form1.ClientHeight,
          CanvasToDraw.Handle,0,0,SRCCOPY);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  px:=-1; py:=-1;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button=mbLeft) then
  begin
    px:=X; py:=Y;
  end;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
   if ssleft in shift then // left mouse button
     if (px<>-1) and (py<>-1) then begin
       Left:=Left+X-px;
       Top:=Top+Y-py;
     end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if (Key=32) then
        HideTitleBorder1Click(sender);

    if (Key=VK_UP) then begin
      if     (ssShift in Shift) and (ssctrl in Shift) then SetBounds(LEFT,TOP,WIDTH,HEIGHT-5)
      else if ssShift in Shift then SetBounds(LEFT,TOP,WIDTH,HEIGHT-1)
      else if ssCtrl in Shift then begin if (Top>0) then Top:=Top-24
                          end else begin if (Top>0) then Top:=Top-1; end;
      if (Top<0) then top:=0;
    end;
    if (Key=VK_DOWN) then begin
      if     (ssShift in Shift) and (ssctrl in Shift) then SetBounds(LEFT,TOP,WIDTH,HEIGHT+5)
      else if ssShift in Shift then SetBounds(LEFT,TOP,WIDTH,HEIGHT+1) // Top:=Top+8
      else if ssCtrl in Shift then begin if (Top<Screen.height-Height) then Top:=Top+24
                          end else begin if (Top<Screen.height-Height) then Top:=Top+1; end;
      if Top>Screen.height-Height then top:=Screen.height-Height;
    end;
    if (Key=VK_LEFT) then begin
      if     (ssShift in Shift) and (ssctrl in Shift) then SetBounds(LEFT,TOP,WIDTH-5,HEIGHT)
      else if ssShift in Shift then SetBounds(LEFT,TOP,WIDTH-1,HEIGHT)
      else if ssCtrl in Shift then begin if (Left>0) then LEFT:=LEFT-24
                          end else begin if (Left>0) then LEFT:=LEFT-1; end;
      if Left<0 then Left:=0;
    end;
    if (Key=VK_RIGHT) then begin
      if     (ssShift in Shift) and (ssctrl in Shift) then SetBounds(LEFT,TOP,WIDTH+5,HEIGHT)
      else if ssShift in Shift then SetBounds(LEFT,TOP,WIDTH+1,HEIGHT)
      else if ssCtrl in Shift then begin if (Left<Screen.Width-Width) then LEFT:=LEFT+24
                          end else begin if (Left<Screen.Width-Width) then LEFT:=LEFT+1; end;
      if Left>Screen.Width-Width then Left:=Screen.Width-Width;
    end;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if (Key=79) or (key=111) or (key=48) then begin FormOptions.Show; FormOptions.SetFocus; end;
    if (Key=88) or (key=120) then
      if ((ssAlt in shift) OR (ssCtrl in shift)) then // strg/alt+x
        Close
      else
        zwinker(666);

    if (ssCtrl   in shift) and ((key=80) or (key=112)) then
        DeletePeaks;
end;

procedure TForm1.config_read;
var W, H, L, T : integer;
    j          : Int64;
    inistr     : array [0..259] of char;
    s          : string;
begin
  L:=Screen.Width -(Screen.Width  div 12)-32;
  T:=Screen.Height-(Screen.Height div 16)-32; 
  W:=Screen.Width div 12; 
  H:=Screen.Height div 16;
  L:=GetPrivateProfileInt('TrafficMonitor','ScreenX',L,PChar(ini_file));
  T:=GetPrivateProfileInt('TrafficMonitor','ScreenY',T,PChar(ini_file));
  W:=GetPrivateProfileInt('TrafficMonitor','ScreenW',W,PChar(ini_file));
  H:=GetPrivateProfileInt('TrafficMonitor','ScreenH',H,PChar(ini_file));
  if (L<-4) then l:=-4; if (L>Screen.Width) then L:= Screen.Width div 8;
  if (T<-4) then t:=-4; if (t>Screen.Width) then t:= Screen.Height div 8;
  if (w<20) then w:=Screen.Width  div 12; if (w>Screen.Width+4) then w:= Screen.Width;
  if (H<20) then h:=Screen.Height div 16; if (h>Screen.Width+4) then h:= Screen.Width;
  SetBounds(L, T, W, H);

  TotDL:=GetPrivateProfileInt('TrafficMonitor','TotalBytesDL',0,PChar(ini_file));
  TotUL:=GetPrivateProfileInt('TrafficMonitor','TotalBytesUL',0,PChar(ini_file));
  j:=9999; j:=GetPrivateProfileInt('TrafficMonitor','Adapter',j,PChar(ini_file));
  if j=9999 then AdapterItemIndex:=0 else AdapterItemIndex:=j;
  j:=3;j:=GetPrivateProfileInt('TrafficMonitor','AverageDistance',j,PChar(ini_file));
  avg_value:=j;
  j:=1000; j:=GetPrivateProfileInt('TrafficMonitor','UpdateInterval',j,PChar(ini_file));
  Timer1.Interval:=j;

  j := GetPrivateProfileString('TrafficMonitor','AverageValues', 'FALSE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bAverage:=TRUE else bAverage:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','SeparateValues', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bSeparate:=TRUE else bSeparate:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','ScaleEqually', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bScaleEqually:=TRUE else bScaleEqually:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','ClickThrough', 'FALSE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bClickThrough:=TRUE else bClickThrough:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','AlwaysOnTop', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bOnTop:=TRUE else bOnTop:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','HideOnMouseOver', 'FALSE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bHideOnMouseOver:=TRUE else bHideOnMouseOver:=FALSE;


  j := GetPrivateProfileString('TrafficMonitor','ShowInAltTab', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bShowInAltTab:=TRUE else bShowInAltTab:=FALSE;

  j := GetPrivateProfileString('TrafficMonitor','ShowInTaskbar', 'FALSE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bShowInTaskbar:=TRUE else bShowInTaskbar:=FALSE;

  j := GetPrivateProfileString('TrafficMonitor','HideBorder', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bHideBorder:=TRUE else bHideBorder:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','HideCaption', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bHideCaption:=TRUE else bHideCaption:=FALSE;

  j := GetPrivateProfileString('TrafficMonitor','FilledGraph', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='FALSE' then bFilledGraph:=FALSE else bFilledGraph:=TRUE;
  j := GetPrivateProfileString('TrafficMonitor','FontBold', 'FALSE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bBold:=TRUE else bBold:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','ShowShadow', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bShadow:=TRUE else bShadow:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','ValuesInColor', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bValuesInColor:=TRUE else bValuesInColor:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','ShowDL', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bDL:=TRUE else bDL:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','ShowDLAvg', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bDLAvg:=TRUE else bDLAvg:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','ShowUL', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bUL:=TRUE else bUL:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','ShowULAvg', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bULAvg:=TRUE else bULAvg:=FALSE;
  j := GetPrivateProfileString('TrafficMonitor','GridUnits', 'FALSE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bGridunits:=TRUE else bGridunits:=FALSE;

  // colors //
  j := GetPrivateProfileString('TrafficMonitor','ColorBG', '$303030',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColBG:=$303030 else ColBG:=StringToColor(s);
  j := GetPrivateProfileString('TrafficMonitor','ColorCombined', 'clYellow',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColComb:=clYellow else ColComb:=StringToColor(s);
  j := GetPrivateProfileString('TrafficMonitor','ColorBorder', '$c0c0c0',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColBorder:=$c0c0c0 else ColBorder:=StringToColor(s);
  j := GetPrivateProfileString('TrafficMonitor','ColorGrid', '$c0c0c0',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColGrid:=$c0c0c0 else ColGrid:=StringToColor(s);
  j := GetPrivateProfileString('TrafficMonitor','ColorLabels', 'clWhite',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColFont:=clWhite else ColFont:=StringToColor(s);
  j := GetPrivateProfileString('TrafficMonitor','ColorShadow', 'clBlack',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColShadow:=clBlack else ColShadow:=StringToColor(s);
  j := GetPrivateProfileString('TrafficMonitor','ColorSeparate', 'clBlack',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColSeparate:=clBlack else ColSeparate:=StringToColor(s);
  j := GetPrivateProfileString('TrafficMonitor','ColorDL', 'clGreen',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColDL:=clGreen else ColDL:=StringToColor(s);
  j := GetPrivateProfileString('TrafficMonitor','ColorDLAvg', 'clLime',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColDLAvg:=clLime else ColDLAvg:=StringToColor(s);
  j := GetPrivateProfileString('TrafficMonitor','ColorUL', 'clMaroon',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColUL:=clMaroon else ColUL:=StringToColor(s);
  j := GetPrivateProfileString('TrafficMonitor','ColorULAvg', 'clRed',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='' then ColULAvg:=clRed else ColULAvg:=StringToColor(s);

  FontName:='Tahoma';
  j:=GetPrivateProfileString('TrafficMonitor','FontName', 'Tahoma',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then FontName := Copy(inistr, 1, j);
  j:=GetPrivateProfileString('TrafficMonitor','LinkedWindow', '',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then LinkedWindow := Copy(inistr, 1, j);

  j:=30; j:=GetPrivateProfileInt('TrafficMonitor','Transparency',j,PChar(ini_file));
  tpCount:=j;
  AlphaBlendValue:=Trunc((100-tpCount)/100*255);
  if AlphaBlendValue<255 then AlphaBlend:=TRUE else AlphaBlend:=FALSE;
  j:=2; j:=GetPrivateProfileInt('TrafficMonitor','GridUnit',j,PChar(ini_file));
  gridunit:=j;
  j:=0; j:=GetPrivateProfileInt('TrafficMonitor','LevelWidth',j,PChar(ini_file));
  LevelWidth:=j;
  j:=1; j:=GetPrivateProfileInt('TrafficMonitor','PixelWidth',j,PChar(ini_file));
  PixelWidth:=j;
  j:=GetPrivateProfileString('TrafficMonitor','ShowBackground', 'TRUE',inistr,sizeof(inistr),PChar(ini_file));
  if inistr[0]<>#0 then s := Copy(inistr, 1, j);
  if s='TRUE' then bBG:=TRUE else bBG:=FALSE;

  j:=0; j:=GetPrivateProfileInt('TrafficMonitor','BorderLines',j,PChar(ini_file));
  iBorderLines:=j;
  j:=1; j:=GetPrivateProfileInt('TrafficMonitor','DrawMode',j,PChar(ini_file));
  drawmode:=j;
  j:=12;j:=GetPrivateProfileInt('TrafficMonitor','FontSize',j,PChar(ini_file));
  FontSize:=j;
  j:=1; j:=GetPrivateProfileInt('TrafficMonitor','ShadowMode',j,PChar(ini_file));
  ShadowMode:=j;
  j:=0; j:=GetPrivateProfileInt('TrafficMonitor','FancyMode',j,PChar(ini_file));
  iFancyState:=j;
  j:=1; j:=GetPrivateProfileInt('TrafficMonitor','ShowLabels',j,PChar(ini_file));
  iFontState:=j;

  mIgnoreMouse.Checked:=bClickThrough;
  mAlwaysonTop.Checked:=bOnTop;
  mHideonMouseOver.Checked:=bHideOnMouseOver;
  TimerWindow.Enabled:=bHideOnMouseOver;
end;

procedure TForm1.config_write;
begin
   if Form1.Left<0 then Form1.Left:=0;
   if Form1.top<0 then Form1.top:=0;
   WritePrivateProfileString('TrafficMonitor','ScreenX', PChar(IntToStr(Form1.Left  )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ScreenY', PChar(IntToStr(Form1.Top   )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ScreenW', PChar(IntToStr(Form1.Width )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ScreenH', PChar(IntToStr(Form1.Height)), PChar(ini_file));

   WritePrivateProfileString('TrafficMonitor','AverageDistance', PChar(IntToStr(avg_value)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','UpdateInterval' , PChar(IntToStr(Timer1.Interval)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','Adapter' , PChar(IntToStr(AdapterItemIndex)), PChar(ini_file));

   WritePrivateProfileString('TrafficMonitor','TotalBytesDL', PChar(IntToStr(TotDL+WSessDLCurr)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','TotalBytesUL', PChar(IntToStr(TotDL+WSessDLCurr)), PChar(ini_file));

   WritePrivateProfileString('TrafficMonitor','ColorBG'    , PChar(ColorToString(ColBG   )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ColorCombined', PChar(ColorToString(ColComb   )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ColorBorder'  , PChar(ColorToString(ColBorder )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ColorGrid'  , PChar(ColorToString(ColGrid )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ColorLabels', PChar(ColorToString(ColFont )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ColorShadow', PChar(ColorToString(ColShadow )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ColorSeparate', PChar(ColorToString(ColSeparate )), PChar(ini_file));

   WritePrivateProfileString('TrafficMonitor','ColorDL'    , PChar(ColorToString(ColDL   )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ColorDLAvg' , PChar(ColorToString(ColDLAvg)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ColorUL'    , PChar(ColorToString(ColUL   )), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ColorULAvg' , PChar(ColorToString(ColULAvg)), PChar(ini_file));

   WritePrivateProfileString('TrafficMonitor','LevelWidth' , PChar(IntToStr(LevelWidth)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','PixelWidth' , PChar(IntToStr(PixelWidth)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','GridUnit' , PChar(IntToStr(gridunit)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','Transparency' , PChar(IntToStr(tpCount)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ShowLabels' , PChar(IntToStr(iFontState)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','FancyMode' , PChar(IntToStr(iFancyState)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','BorderLines' , PChar(IntToStr(iBorderlines)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','DrawMode' , PChar(IntToStr(drawmode)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','ShadowMode' , PChar(IntToStr(ShadowMode)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','FontSize' , PChar(IntToStr(FontSize)), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','FontName' , PChar(FontName), PChar(ini_file));
   WritePrivateProfileString('TrafficMonitor','LinkedWindow' , PChar(LinkedWindow), PChar(ini_file));

   if bGridunits then WritePrivateProfileString('TrafficMonitor','GridUnits',PChar('TRUE'),PChar(ini_file))
                 else WritePrivateProfileString('TrafficMonitor','GridUnits',PChar('FALSE'),PChar(ini_file));
   if bOnTop then WritePrivateProfileString('TrafficMonitor','AlwaysOnTop',PChar('TRUE'),PChar(ini_file))
             else WritePrivateProfileString('TrafficMonitor','AlwaysOnTop',PChar('FALSE'),PChar(ini_file));


   if bShowInaltTab then WritePrivateProfileString('TrafficMonitor','ShowInAltTab',PChar('TRUE'),PChar(ini_file))
                    else WritePrivateProfileString('TrafficMonitor','ShowInAltTab',PChar('FALSE'),PChar(ini_file));
   if bShowInTaskbar then WritePrivateProfileString('TrafficMonitor','ShowInTaskbar',PChar('TRUE'),PChar(ini_file))
                     else WritePrivateProfileString('TrafficMonitor','ShowInTaskbar',PChar('FALSE'),PChar(ini_file));
   if bHideBorder then WritePrivateProfileString('TrafficMonitor','HideBorder',PChar('TRUE'),PChar(ini_file))
                  else WritePrivateProfileString('TrafficMonitor','HideBorder',PChar('FALSE'),PChar(ini_file));
   if bHideCaption then WritePrivateProfileString('TrafficMonitor','HideCaption',PChar('TRUE'),PChar(ini_file))
                   else WritePrivateProfileString('TrafficMonitor','HideCaption',PChar('FALSE'),PChar(ini_file));
   if bClickThrough then WritePrivateProfileString('TrafficMonitor','ClickThrough',PChar('TRUE'),PChar(ini_file))
                    else WritePrivateProfileString('TrafficMonitor','ClickThrough',PChar('FALSE'),PChar(ini_file));
   if bHideOnMouseOver then WritePrivateProfileString('TrafficMonitor','HideOnMouseOver',PChar('TRUE'),PChar(ini_file))
                       else WritePrivateProfileString('TrafficMonitor','HideOnMouseOver',PChar('FALSE'),PChar(ini_file));
   if bSeparate then WritePrivateProfileString('TrafficMonitor','SeparateValues',PChar('TRUE'),PChar(ini_file))
                else WritePrivateProfileString('TrafficMonitor','SeparateValues',PChar('FALSE'),PChar(ini_file));
   if bScaleEqually then WritePrivateProfileString('TrafficMonitor','ScaleEqually',PChar('TRUE'),PChar(ini_file))
                    else WritePrivateProfileString('TrafficMonitor','ScaleEqually',PChar('FALSE'),PChar(ini_file));
   if bAverage then WritePrivateProfileString('TrafficMonitor','AverageValues',PChar('TRUE'),PChar(ini_file))
               else WritePrivateProfileString('TrafficMonitor','AverageValues',PChar('FALSE'),PChar(ini_file));
   if bFilledGraph then WritePrivateProfileString('TrafficMonitor','FilledGraph',PChar('TRUE'),PChar(ini_file))
                   else WritePrivateProfileString('TrafficMonitor','FilledGraph',PChar('FALSE'),PChar(ini_file));
   if bBG then WritePrivateProfileString('TrafficMonitor','ShowBackground',PChar('TRUE'),PChar(ini_file))
          else WritePrivateProfileString('TrafficMonitor','Showbackground',PChar('FALSE'),PChar(ini_file));
   if bBold then WritePrivateProfileString('TrafficMonitor','FontBold',PChar('TRUE'),PChar(ini_file))
            else WritePrivateProfileString('TrafficMonitor','FontBold',PChar('FALSE'),PChar(ini_file));
   if bValuesInColor then WritePrivateProfileString('TrafficMonitor','ValuesInColor',PChar('TRUE'),PChar(ini_file))
                     else WritePrivateProfileString('TrafficMonitor','ValuesInColor',PChar('FALSE'),PChar(ini_file));
   if bShadow then WritePrivateProfileString('TrafficMonitor','ShowShadow',PChar('TRUE'),PChar(ini_file))
              else WritePrivateProfileString('TrafficMonitor','ShowShadow',PChar('FALSE'),PChar(ini_file));

   if bDL then WritePrivateProfileString('TrafficMonitor','ShowDL',PChar('TRUE'),PChar(ini_file))
          else WritePrivateProfileString('TrafficMonitor','ShowDL',PChar('FALSE'),PChar(ini_file));
   if bDLAvg then WritePrivateProfileString('TrafficMonitor','ShowDLAvg',PChar('TRUE'),PChar(ini_file))
             else WritePrivateProfileString('TrafficMonitor','ShowDLAvg',PChar('FALSE'),PChar(ini_file));
   if bUL then WritePrivateProfileString('TrafficMonitor','ShowUL',PChar('TRUE'),PChar(ini_file))
          else WritePrivateProfileString('TrafficMonitor','ShowUL',PChar('FALSE'),PChar(ini_file));
   if bULAvg then WritePrivateProfileString('TrafficMonitor','ShowULAvg',PChar('TRUE'),PChar(ini_file))
             else WritePrivateProfileString('TrafficMonitor','ShowULAvg',PChar('FALSE'),PChar(ini_file));
end;

function IntToSize(I: double): string;
begin
if      I >= (1000.0*1000.0*1000.0*1000.0) then Result := Format('%1.3f',[I / (1024.0*1024.0*1024.0*1024.0)])+' TB'   //Format('%1.3f TB',[I / (1024.0*1024.0*1024.0*1024.0)])
else if I >= (1000.0*1000.0*1000.0)        then Result := Format('%1.2f',[I / (1024.0*1024.0*1024.0)])+' GB'   //Format('%1.3f GB',[I / (1024.0*1024.0*1024.0)])
else if I >= (1000.0*1000.0)               then Result := Format('%1.2f',[I / (1024.0*1024.0)])+' MB'   //Format('%1.2f MB',[I / (1024.0*1024.0)])
else                                            Result := Format('%1.1f',[I / (1024.0)])+' kB'   //Format('%1.1f kB',[I / (1024.0)])
end;

function IntToSizeShort(I: double): string;
begin
if      I >= (1000.0*1000.0*1000.0*1000.0) then Result := Format('%1.3f',[I / (1024.0*1024.0*1024.0*1024.0)])+'T' //Format('%1.0f T',[I / (1024.0*1024.0*1024.0*1024.0)])
else if I >= (1000.0*1000.0*1000.0)        then Result := Format('%1.2f',[I / (1024.0*1024.0*1024.0)])+'G' //Format('%1.1f G',[I / (1024.0*1024.0*1024.0)])
else if I >= (1000.0*1000.0)               then Result := Format('%1.2f',[I / (1024.0*1024.0)])+'M' //Format('%1.1f M',[I / (1024.0*1024.0)])
else                                            Result := Format('%1.0f',[I / (1024.0)])+'k' //Format('%1.1f k',[I / (1024.0)])
end;

function IntToSizeNoSize(I: double): string;
begin
if      I >= (1000.0*1000.0*1000.0*1000.0) then Result := Format('%1.3f',[I / (1024.0*1024.0*1024.0*1024.0)]) //Format('%1.3f',[I / (1024.0*1024.0*1024.0*1024.0)])
else if I >= (1000.0*1000.0*1000.0)        then Result := Format('%1.2f',[I / (1024.0*1024.0*1024.0)]) //Format('%1.3f',[I / (1024.0*1024.0*1024.0)])
else if I >= (1000.0*1000.0)               then Result := Format('%1.2f',[I / (1024.0*1024.0)]) //Format('%1.2f',[I / (1024.0*1024.0)])
else                                            Result := Format('%1.1f',[I / (1024.0)]) //Format('%1.1f',[I / (1024.0)])
end;

function IntToSizeNoSizeNoKomma(I: double): string;
begin
if      I >= (1000.0*1000.0*1000.0*1000.0) then Result := Format('%1.0f',[I / (1024.0*1024.0*1024.0*1024.0)])
else if I >= (1000.0*1000.0*1000.0)        then Result := Format('%1.0f',[I / (1024.0*1024.0*1024.0)])
else if I >= (1000.0*1000.0)               then Result := Format('%1.0f',[I / (1024.0*1024.0)])
else                                            Result := Format('%1.0f',[I / (1024.0)])
end;

procedure TForm1.zwinker(i: integer);
begin
   Application.ProcessMessages;
   zwink:=true;
   while i>25 do begin
     BitBlt(Form1.Canvas.Handle,0,0,Form1.ClientWidth,Form1.ClientHeight,
            CanvasToDraw.Handle,0,0,DSTINVERT);
     Sleep(i div 2);
     BitBlt(Form1.Canvas.Handle,0,0,Form1.ClientWidth,Form1.ClientHeight,
            CanvasToDraw.Handle,0,0,DSTINVERT);
     Sleep(i div 8);
     i:=i div 2;
   end;
   zwink:=false;
end;

procedure TForm1.MakeShadedPalette(var pal: array of TColor; Color: TColor; max: integer);
var i              : integer;
begin
  for i:=0 to max-1 do
    if      (iFancyState=1) and (Color= ColUL) and (drawmode=2) then
    pal[max-i]:=Darker(Color, i, max)
    else if (iFancyState=2) and (Color= ColUL) and (drawmode=2) then
    pal[    i]:=Darker(Color, i, max)
    else if  iFancyState=1                                      then
    pal[    i]:=Darker(Color, i, max)
    else if  iFancyState=2                                      then
    pal[max-i]:=Darker(Color, i, max);
end;

procedure TForm1.MakeShadedPalettes;
var h: integer;
    outtype, outfontsize, outheight: integer;
begin
    updating:=true;
    outheight:=0;
    h:=Display.Height;
    if bSeparate and (iFontState>0) then begin
      CanvasToDraw.Font.Size:=FontSize;
      GetSeparatedAreaVars(outtype, outfontsize, outheight);
      h:=h-outheight+1;
    end;

    if display.Height<outheight then
    begin
      updating:=false;
      exit;
    end;
    if drawmode<>1 then
      h:=(h div 2);

    SetLength(palCombined, h+1);
    SetLength(palDownload, h+1);
    SetLength(palUpload  , h+1);

    MakeShadedPalette(palCombined, ColComb, h);
    MakeShadedPalette(palDownload, ColDL  , h);
    MakeShadedPalette(palUpload  , ColUL  , h);
    updating:=false;
end;

function InvertColor(color: TColor): TColor;
var r,g,b: byte;
begin
  Color := ColorToRGB(color);
  b := (Color shr 16) and $FF;
  g := (Color shr 8) and $FF;
  r := (Color and $FF);
  b := 255 - b;
  g := 255 - g;
  r := 255 - r;
  result := (b shl 16) or (g shl 8) or r;
end;

function TForm1.Darker(color: TColor; val, max: Integer): TColor;
var r,g,b   : integer;
    x:integer;
begin
  b := (Color shr 16) and $FF;
  g := (Color shr 8) and $FF;
  r := (Color and $FF);
  b:=(b-Trunc(val/max*255)) div 2;
  g:=(g-Trunc(val/max*255)) div 2;
  r:=(r-Trunc(val/max*255)) div 2;
  if (r<0) then r:=0;
  if (g<0) then g:=0;
  if (b<0) then b:=0;
  result := (b shl 16) or (g shl 8) or r;
end;

function TForm1.Lighter(color: TColor; val, max: Integer): TColor;
var r,g,b: word;
begin
  Color := ColorToRGB(color);
  b := (Color shr 16) and $FF;
  g := (Color shr 8) and $FF;
  r := (Color and $FF);
  b:=b+Trunc(val/max*b);
  g:=g+Trunc(val/max*g);
  r:=r+Trunc(val/max*r);
  if (r>255) then r:=255;
  if (g>255) then g:=255;
  if (b>255) then b:=255;
  result := (b shl 16) or (g shl 8) or r;
end;

function TForm1.Lighter(col1,col2: TColor; val, max: Integer): TColor;
  function farbverlauf(fbegin, fend: TColor; fval, fmax: Integer): TColor;
  var r1,g1,b1,r2,g2,b2,r,g,b: Byte; fval2: Integer;
  begin
    r1:=Byte(fbegin);
    g1:=Byte(fbegin shr 8);
    b1:=Byte(fbegin shr 16);
    r2:=Byte(fend);
    g2:=Byte(fend shr 8);
    b2:=Byte(fend shr 16);
    fval2:=fmax-fval;
    r:=Round((r1*fval2+r2*fval)/fmax);
    g:=Round((g1*fval2+g2*fval)/fmax);
    b:=Round((b1*fval2+b2*fval)/fmax);
    result:=RGB(r,g,b);
  end;
var r1,g1,b1,r2,g2,b2,r,g,b: word;
begin
  result:=farbverlauf(col1,col2,val,max);
end;

///////////////////////////////////////////////////

procedure TForm1.mResetGraphClick(Sender: TObject);
var i: integer;
begin
    Timer1.Enabled:=FALSE;
    displaypopup.tag:=0;
    bfull:=false;
    SpeedCounter:=0;
    maxdownspeed:=0;
    maxupspeed:=0;
    lastInOct :=0;
    lastOutOct:=0;
    DrawGraph;
    Timer1.Enabled:=TRUE;
end;

procedure TForm1.mOptionsClick(Sender: TObject);
begin
    displaypopup.tag:=0;
    FormOptions.Visible:=True;
    SetForegroundWindow(FormOptions.Handle);
    FormOptions.SetFocus;
end;

procedure TForm1.mCloseClick(Sender: TObject);
begin
  displaypopup.tag:=0;
  close;
end;

procedure TForm1.mHideClick(Sender: TObject);
begin
  displaypopup.tag:=0;
  ToggleHIDE;
end;

procedure TForm1.mSmoothPeaksClick(Sender: TObject);
begin
  displaypopup.tag:=0;
  Form1.mPeakClick(Sender);
end;

procedure TForm1.mHideonMouseOverClick(Sender: TObject);
begin
  displaypopup.tag:=0;
  FormOptions.HideOnMouseOver.Checked:=not FormOptions.HideOnMouseOver.Checked;
end;

procedure TForm1.mIgnoreMouseClick(Sender: TObject);
begin
  displaypopup.tag:=0;
  FormOptions.cbClickThrough.Checked:=not FormOptions.cbClickThrough.Checked;
end;

procedure TForm1.HideTitleBorder1Click(Sender: TObject);
begin
  displaypopup.tag:=0;
  FormOptions.HideBorder.Checked:= not FormOptions.HideBorder.checked;
end;

procedure TForm1.mAlwaysonTopClick(Sender: TObject);
begin
  displaypopup.tag:=0;
  FormOptions.AlwaysOnTop.Checked:=not FormOptions.AlwaysOnTop.Checked;
end;

procedure TForm1.mPeakClick(Sender: TObject);
begin
  displaypopup.tag:=0;
  DeletePeaks;
end;
///////////////////////////////////////////////////

procedure TForm1.rafMon101Click(Sender: TObject);
begin
  displaypopup.tag:=0;
  //zwinker(666);
end;

procedure TForm1.ScrDblClick(Sender: TObject);
begin
    FormOptions.Visible:=True;
    SetForegroundWindow(FormOptions.Handle);
    FormOptions.SetFocus;
end;

procedure TForm1.ToggleHide;
var L,T,W,H:integer;
begin
  if mHide.caption='&Hide' then begin
      mHide.caption:='S&how';
      visible:=false;
  end else begin
      mHide.caption:='&Hide';
      visible:=true;
      l:=Left; t:=Top; w:=Width; h:=Height;
      if (L<-4) then l:=-4; if (L>Screen.Width) then L:= Screen.Width div 8;
      if (T<-4) then t:=-4; if (t>Screen.Width) then t:= Screen.Height div 8;
      if (w<20) then w:=Screen.Width  div 12; if (w>Screen.Width+4) then w:= Screen.Width;
      if (H<20) then h:=Screen.Height div 16; if (h>Screen.Width+4) then h:= Screen.Width;
      SetBounds(L, T, W, H);

      ShowWindow(form1.Handle,SW_SHOWNOACTIVATE);
      DrawGraph;
  end;
  FormOptions.button4.caption:=mHide.caption;
  SetFormStyleExternal;
  if bOnTop then begin
  SetWindowPos(form1.Handle,HWND_TOPMOST, 0,0,0,0,
               SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED)
  end else
  SetWindowPos(form1.Handle,HWND_NOTOPMOST, 0,0,0,0,
               SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED)
end;


procedure TForm1.TaskbarEvent(var Msg: TMessage);
var Point : TPoint;
    tMsg:tagMSG;
begin
  case Msg.LParam of
    WM_LBUTTONDBLCLK:
      begin
        clicktimer.tag:=-1;
        clicktimer.Enabled:=false;
        //popupvisible:=true;
        FormOptions.Visible := True;
        SetForegroundWindow(FormOptions.Handle);
        FormOptions.SetFocus;
        doubleclicked:=true;
      end;
    WM_LBUTTONUP:
      begin
        if (not FormOptions.Visible) then begin
          if Form1.Visible then
          begin
            SetForegroundWindow(Handle);
            SetFocus;
          end;
        end;
        clicktimer.Enabled:=true;
        clicktimer.tag:=clicktimer.tag+1;
      end;
    WM_RBUTTONUP:
      begin
        // damit das PopupMenu korrekt wieder geschlossen wird
        SetForegroundWindow(Handle);

        // PopupMenu anzeigen
        GetCursorPos(Point);
        //displaypopup.tag:=666;
        displaypopup.Popup(Point.x, Point.y);

        //warten damit falls nicht in men sondern in irgend andere Control
        //geklickt wird, unten gedrckt wieder entfernt wird
        while PeekMessage(tMsg, 0, WM_MOUSEFIRST, WM_MOUSELAST, PM_REMOVE) do;
        MouseUp(mbLeft,[],1,1);

        Application.ProcessMessages;
        displaypopup.tag:=0;
        TimerWindow.Enabled:=true;
        timer1.Enabled:=false;
        clicktimer.Enabled:=false;
        Application.ProcessMessages;
        displaypopup.tag:=0;

        //inc(SpeedCounter);
        //DrawGraph;
      end;
  end;
end;

procedure TForm1.logappend(s:string);
var f : TextFile;
    logfname: string;
begin
  logfname:='trafmon.log';
  FileMode:=fmOpenWrite;
  {$I-}
  if FileExists(logfname) then
  begin
    AssignFile(f, logfname);
    Append(f);
  end else begin
    AssignFile(f, logfname);
    Rewrite(f);
  end;
  {$I+}
  Writeln(f, s);
  CloseFile(f);
end;

procedure TForm1.DrawBMasIcon(bm: TBitmap; transparent: Boolean; tip: string);
var
  AndMask : TBitmap;
  XOrMask : TBitmap;
  IconInfo : TIconInfo;
  c,cp,x,y:Integer;
  Icn : TIcon;
begin
    Icn := TIcon.Create;
    Icn.Width:=bm.Width;
    Icn.Height:=bm.Height;

    {Create the "And" mask}
    AndMask := TBitmap.Create;
    AndMask.Width := Icn.Width;
    AndMask.Height := Icn.Height;
    AndMask.Monochrome := true;
    {Clear the "And" mask}
    AndMask.Canvas.Brush.Color := clBlack;
    AndMask.Canvas.FillRect(Rect(0,0,Icn.Width,Icn.Height));

    {Create the "XOr" mask}
    XOrMask := TBitmap.Create;
    XOrMask.Width := Icn.Width;
    XOrMask.Height := Icn.Height;
    {Clear the "XOr" mask}
    XOrMask.Canvas.Brush.Color := clWhite;
    XOrMask.Canvas.FillRect(Rect(0,0,Icn.Width,Icn.Height));

    {Copy the Bitmap}
    cp := bm.Canvas.Pixels[0,0]; // remember transparent BIT
    For x := 0 to Icn.Width-1 do Begin
      For y := 0 to Icn.Height-1 do Begin
        c := bm.Canvas.Pixels[x,y];
        if transparent then begin
          If c = cp Then
            AndMask.Canvas.Pixels[x,y] := clWhite;
          If c <> cp Then
            XOrMask.Canvas.Pixels[x,y] := c;
        end else begin
          AndMask.Canvas.Pixels[x,y] := clBlack;
          XOrMask.Canvas.Pixels[x,y] := c;
        end;
      End;
    End;

    {Create icn}
    IconInfo.fIcon := true;
    IconInfo.xHotspot := 0;
    IconInfo.yHotspot := 0;
    IconInfo.hbmMask  := AndMask.Handle;
    IconInfo.hbmColor := XOrMask.Handle;
    Icn.Handle := CreateIconIndirect(IconInfo);

{$IFDEF VER150}
    StrCopy(NotifyIconData.szTip, PAnsiChar(tip));
{$ELSE}
    StrCopy(@NotifyIconData.szTip, PChar(tip));
{$ENDIF}
    NotifyIconData.hIcon  := Icn.Handle;
    NotifyIconData.uFlags:=NIF_ICON or NIF_TIP;
    Shell_NotifyIcon(NIM_MODIFY, @NotifyIconData);

    AndMask.Free;
    XOrMask.Free;
    Icn.Destroy;
end;

procedure TForm1.SetFormStyleExternal;
var strs: TStringList;
    exstyle : ULONG;
    wnd: HWND;
    i:integer;
    s,clname:string;
    lStyle:ULONG;
begin
  if LinkedWindow='' then exit;
  s:='"'+ReplaceCharInString(LinkedWindow,',','","')+'"';
  strs:=TStringList.Create;
  strs.CommaText:=s;
  for i:=0 to strs.Count-1 do
  begin
    wnd:=FindWindow(nil,PChar(strs.strings[i]));
    if wnd<>0 then
    begin
      exstyle:=GetWindowLong(wnd, GWL_EXSTYLE);
      SetWinStyle(exstyle,WS_EX_LAYERED    ,bClickThrough or (not bBG) or (Form1.AlphaBlendValue<255));
      SetWinStyle(exstyle,WS_EX_TRANSPARENT,bClickThrough);
      SetWindowLong(wnd, GWL_EXSTYLE, exstyle);
      if bBG then SetLayeredWindowAttributes(wnd,ColBG,Trunc((100-tpCount)/100*255),LWA_ALPHA)
             else SetLayeredWindowAttributes(wnd,ColBG,Trunc((100-tpCount)/100*255),LWA_COLORKEY OR LWA_ALPHA);
      if bOnTop then SetWindowPos(wnd,HWND_TOPMOST  , 0,0,0,0, SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED)
                else SetWindowPos(wnd,HWND_NOTOPMOST, 0,0,0,0, SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED);
    end;
  end;
end;

procedure TForm1.SetFormStyle;
var style   : ULONG;
    exstyle : ULONG;
begin
    SetFormStyleExternal;

    ShowWindow(Application.Handle, SW_HIDE);
    //ShowWindow(Handle, SW_HIDE);

    if bShowInaltTab then begin BorderStyle:=bsSizeable;  Shell_NotifyIcon(NIM_DELETE, @NotifyIconData); CreateTrayIcon; end
                     else begin BorderStyle:=bsToolWindow; Shell_NotifyIcon(NIM_DELETE, @NotifyIconData); CreateTrayIcon; end;

    // read current styles
    style   := GetWindowLong(Handle, GWL_STYLE);
    exstyle := GetWindowLong(Handle, GWL_EXSTYLE);

    // modify the styles
    SetWinStyle(  style,WS_THICKFRAME    ,(not bClickThrough) and (not bHideBorder));
    SetWinStyle(  style,WS_MINIMIZEBOX   ,FALSE);
    SetWinStyle(  style,WS_MAXIMIZEBOX   ,FALSE);
    SetWinStyle(  style,WS_SYSMENU       ,FALSE);
    SetWinStyle(  style,WS_CAPTION       ,not bHideCaption);
    SetWinStyle(exstyle,WS_EX_LAYERED    ,bClickThrough or (not bBG) or (AlphaBlendValue<255));
    SetWinStyle(exstyle,WS_EX_TRANSPARENT,bClickThrough);

    // set the styles
    SetWindowLong(Handle, GWL_STYLE  ,   style);
    SetWindowLong(Handle, GWL_EXSTYLE, exstyle);

    AlphaBlendValue := Trunc( (100-tpCount)/100*255 );
    if AlphaBlendValue<255 then AlphaBlend:=TRUE
                           else AlphaBlend:=FALSE;

    if bBG then SetLayeredWindowAttributes(Handle,ColBG,Trunc((100-tpCount)/100*255),LWA_ALPHA)
           else SetLayeredWindowAttributes(Handle,ColBG,Trunc((100-tpCount)/100*255),LWA_COLORKEY OR LWA_ALPHA);

    if bShowInTaskbar then ShowWindow(Application.Handle,SW_SHOW)
                      else ShowWindow(Application.Handle,SW_HIDE);
    //ShowWindow(Handle,SW_SHOW);

    //If you have changed certain window data using
    //SetWindowLong, you must call SetWindowPos for
    //the changes to take effect with following uFlags:
    //SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER | SWP_FRAMECHANGED.
    //SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW OR SWP_NOACTIVATE
    if bOnTop then SetWindowPos(Handle,HWND_TOPMOST  ,0,0,0,0, SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED)
                                              //SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE)
              else SetWindowPos(Handle,HWND_NOTOPMOST,0,0,0,0, SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED);
                                              //SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE);
end;

procedure TForm1.VerticalTextOut(C: TCanvas; x,y: integer; const s: string);
var
  lf: TLogFont;
  OldFontHdl,NewFontHdl: HFont;
begin
  if s = '' then exit;
  with C do
  begin
    if GetObject(Font.Handle, SizeOf(lf), @lf) = 0 then exit;
    lf.lfEscapement := 90 * 10;
    lf.lfOrientation := 90 * 10;
    lf.lfOutPrecision := OUT_TT_ONLY_PRECIS;
    NewFontHdl := CreateFontIndirect(lf);
    OldFontHdl := selectObject(handle,NewFontHdl);
    TextOut(X, Y, s);
    selectObject(handle,OldFontHdl);
    DeleteObject(NewFontHdl);
  end;
end;

procedure TForm1.ShadowTextOut(C: TCanvas; Color: TColor; X, Y: Integer; s: String);
begin
  if ShadowMode>0 then begin
    C.Font.Color:=ColShadow;
    C.TextOut(x+1 , y  , s);
    C.TextOut(x-1 , y  , s);
    C.TextOut(x   , y+1, s);
    C.TextOut(x   , y-1, s);

    C.TextOut(x+1 , y-1, s);
    C.TextOut(x-1 , y+1, s);
    C.TextOut(x-1 , y-1, s);
    C.TextOut(x+1 , y+1, s);

    if ShadowMode=1 then begin
    C.TextOut(x+1 , y+2, s);
    C.TextOut(x+1 , y-2, s);
    C.TextOut(x-1 , y+2, s);
    C.TextOut(x-1 , y-2, s);

    C.TextOut(x+2 , y+1, s);
    C.TextOut(x+2 , y-1, s);
    C.TextOut(x-2 , y+1, s);
    C.TextOut(x-2 , y-1, s);

    C.TextOut(x-2 , y  , s);
    C.TextOut(x+2 , y  , s);
    C.TextOut(x   , y+2, s);
    C.TextOut(x   , y-2, s);
    end;
  end;
  C.Font.Color:=Color;
  C.TextOut(x, y, s);
end;

procedure TForm1.DrawLineWindows(Canvas: TCanvas; x1,y1,x2,y2,max: Integer; col: TColor);
var P: TPoint;
begin
  Canvas.Pen.Color:=col;
  P.X:=x1;
  P.Y:=y1;
  Canvas.PenPos:=P;
  Canvas.LineTo(x2,y2);
end;

procedure TForm1.DrawLineBresenham(Canvas: TCanvas; x1,y1,x2,y2,max: Integer; col: TColor);
var   step,
      delta,
      delta_x,
      delta_y,
      direction_x,
      direction_y  : Integer;
begin { line algorithm by Bresenham }
  if (x1 < x2) then direction_x := 1
               else direction_x := -1;
  if (y1 < y2) then direction_y := 1
               else direction_y := -1;
  delta_x := ABS (x1 - x2);
  delta_y := ABS (y1 - y2);

  if (delta_x >= delta_y)
  then begin
      delta_y := 2 * delta_y;
      delta := delta_y - delta_x;
      delta_x := 2 * delta_x;
      for step := 0 to (delta_x DIV 2) do
      begin
        if (y1<0) then exit;
        Canvas.Pixels[x1,y1]:=col;
        if (delta > 0) then
        begin
            y1 := y1 + direction_y;
            Inc (delta, delta_y - delta_x);
        end else
            Inc (delta, delta_y);
        Inc (x1, direction_x)
      end
  end else begin
      delta_x := 2 * delta_x;
      delta := delta_x - delta_y;
      delta_y := 2 * delta_y;
      for step := 0 to (delta_y DIV 2) do
      begin
        if (y1<0) then exit;
        Canvas.Pixels[x1,y1]:=col;
        if (delta > 0) then
        begin
            x1 := x1 + direction_x;
            Inc (delta, delta_x - delta_y);
        end else
            Inc (delta, delta_x);
        Inc (y1, direction_y)
      end
  end
end;

type
  TRIVERTEX = packed record
    X, Y : DWORD;
    Red, Green, Blue, Alpha : Word;
  end;

function GradientFill(DC : hDC; pVertex : Pointer; dwNumVertex : DWORD;
  pMesh : Pointer; dwNumMesh, dwMode: DWORD) : DWord; stdcall;
  external 'msimg32.dll';

(*
procedure DrawGradientRect(Canvas:TCanvas; x1,y1,x2,y2: integer; Color1,Color2:TColor);
var vert  : array[0..1] of TRIVERTEX;
    gRect : GRADIENT_RECT;
    r1,g1,b1,r2,g2,b2: integer;
    s:string;
begin
  b1 := (Color1 shr 16) and $FF;
  g1 := (Color1 shr 8) and $FF;
  r1 := (Color1 and $FF);
  b2 := (Color2 shr 16) and $FF;
  g2 := (Color2 shr 8) and $FF;
  r2 := (Color2 and $FF);
  vert [0].x      := x1;
  vert [0].y      := y1;
  vert [0].Red    := MakeWord(0,r1);
  vert [0].Green  := MakeWord(0,g1);
  vert [0].Blue   := MakeWord(0,b1);
  vert [0].Alpha  := $ffff;

  vert [1].x      := x2;
  vert [1].y      := y2;
  vert [1].Red    := MakeWord(0,r2);// shl 4;
  vert [1].Green  := MakeWord(0,g2);// shl 4;
  vert [1].Blue   := MakeWord(0,b2);// shl 4;
  vert [1].Alpha  := $ffff;

  gRect.UpperLeft  := 0;
  gRect.LowerRight := 1;
  GradientFill(Canvas.Handle,@vert,2,@gRect,1,GRADIENT_FILL_RECT_V);
end;
*)

procedure TForm1.DrawLineBresenhamShaded(Canvas:TCanvas; x1,y1,x2,y2,palidx,max:Integer; pal: array of TColor);
var   step,
      delta,
      delta_x,
      delta_y,
      direction_x,
      direction_y  : Integer;
begin { line algorithm by Bresenham }
  (**_)
  if iFancyState=1 then
  DrawGradientRect(Canvas,x1,y1,x2,y2,pal[0],clBlack)
  else
  DrawGradientRect(Canvas,x2,y2,x1,y1,pal[0],clBlack);
  exit;
  (**)

  if (x1 < x2) then direction_x :=  1
               else direction_x := -1;
  if (y1 < y2) then direction_y :=  1
               else direction_y := -1;
  delta_x := ABS (x1 - x2);
  delta_y := ABS (y1 - y2);

  if (delta_x >= delta_y)
  then begin
      delta_y := 2 * delta_y;
      delta := delta_y - delta_x;
      delta_x := 2 * delta_x;
      for step := 0 to (delta_x DIV 2) do
      begin
        if step>Display.Width then break;
        if (y1-palidx<High(pal)) and (y1-palidx>=0) then
          Canvas.Pixels[x1,y1]:=pal[y1-palidx];
        if (delta > 0) then
        begin
            y1 := y1 + direction_y;
            Inc (delta, delta_y - delta_x);
        end else
            Inc (delta, delta_y);
        Inc (x1, direction_x)
      end
  end else begin
      delta_x := 2 * delta_x;
      delta := delta_x - delta_y;
      delta_y := 2 * delta_y;
      for step := 0 to (delta_y DIV 2) do
      begin
        if step>Display.Height then break;
        if (y1-palidx<High(pal)) and (y1-palidx>=0) then
          Canvas.Pixels[x1,y1]:=pal[y1-palidx];
        if (delta > 0) then
        begin
            x1 := x1 + direction_x;
            Inc (delta, delta_x - delta_y);
        end else
            Inc (delta, delta_x);
        Inc (y1, direction_y)
      end
  end
end;

procedure TForm1.DrawShadedRectangle(Canvas: TCanvas; x1,y1,x2,y2,palidx,max: Integer; pal: array of TColor);
var i : integer;
    r: TReader;
begin
    // build rect from differnet shaded lines
    if y1<0 then y1:=0;
    if y2>display.height then y2:=display.height;
    for i:=y1 to y2 do
        DrawLineBresenhamShaded(Canvas,x1,i,x2,i,palidx,max,pal)
        //DrawGradientRect(Canvas,x1,y1,x2+1,y2,pal[0],clBlack);
end;

procedure TForm1.DrawUpDown(Canvas: TCanvas; x,y:integer; up:Boolean; Col:TColor);
var p: TPoint;
begin
     if not up then begin
       Canvas.Pen.Color:=Col;
       p.X:=x-2;
       p.y:=y-2;
       Canvas.PenPos:=P;
       Canvas.LineTo(x, y);
       Canvas.LineTo(x+3, y-3);
     end else begin
       Canvas.Pen.Color:=Col;
       Canvas.Pen.Width:=1;
       p.X:=x-2;
       p.y:=y+2;
       Canvas.PenPos:=P;
       Canvas.LineTo(x, y);
       Canvas.LineTo(x+3, y+3);
     end;
end;

procedure TForm1.SetTextByIndex( outtype: integer; var sDL, sUL: string);
var idl, iul: cardinal;
    sc2: longint;
begin
    if (CurrIfObj=nil) OR ((SpeedCounter=0) and (not bfull)) then exit;
    sc2:=SpeedCounter-1;
    if sc2<0 then sc2:=Screen.Width;
    if bAverage then
    begin
      idl:=(CurrIfObj.SArr[SpeedCounter].DLSpeed+CurrIfObj.SArr[sc2].DLSpeed)div 2;
      iul:=(CurrIfObj.SArr[SpeedCounter].ULSpeed+CurrIfObj.SArr[sc2].ULSpeed)div 2;
    end else begin
      idl:=CurrIfObj.SArr[SpeedCounter].DLSpeed;
      iul:=CurrIfObj.SArr[SpeedCounter].ULSpeed;
    end;
    case outtype of
        0: begin sDL:='DL: '+IntToSize             (idl)+'/s ';
                 sUL:='UL: '+IntToSize             (iul)+'/s '; end;
        1: begin sDL:='DL: '+IntToSize             (idl);
                 sUL:='UL: '+IntToSize             (iul); end;
        2: begin sDL:=       IntToSize             (idl);
                 sUL:=       IntToSize             (iul); end;
        3: begin sDL:=       IntToSizeNoSize       (idl);
                 sUL:=       IntToSizeNoSize       (iul); end;
        4: begin sDL:=       IntToSizeNoSize       (idl);
                 sUL:=       IntToSizeNoSize       (iul); end;
        5: begin sDL:=       IntToSizeNoSizeNoKomma(idl);
                 sUL:=       IntToSizeNoSizeNoKomma(iul); end;
        6: begin sDL:=       IntToSizeNoSizeNoKomma(idl);
                 sUL:=       IntToSizeNoSizeNoKomma(iul); end;
    end; // case
end;

procedure TForm1.GetSeparatedAreaVars(var outtype, outfontsize, outheight: integer);
var k, l, iadd: integer;
    tsD, tsU  : TSize;
    sDL, sUL  : string;
begin
   l:=0;
   tsD.cx:=0;
   tsU.cx:=0;
   if bSeparate then iadd:=12 else iadd:=0;
   repeat
       k:=l mod 7;
       SetTextByIndex(k, sDL, sUL);
       inc(l);
       tsD:=CanvasToDraw.TextExtent(sDL);
       tsU:=CanvasToDraw.TextExtent(sUL);
       if (drawmode=0) and not (bSeparate) then begin
         tsD.cx:=tsD.cx div 2;
         tsU.cx:=tsU.cx div 2;
       end;
       if l mod 7 = 0 then
       begin
         CanvasToDraw.Font.Size:=CanvasToDraw.Font.Size-1;
       end;
   until ((tsD.cx+tsU.cx+iadd <= Display.Width) and
          (tsD.cy-4           <= Display.Height)       ) or
         (CanvasToDraw.Font.Size<=7);
   SeparateWidth:=0;
   if bSeparate then
       SeparateWidth:=tsD.cy;
   outtype:=k;
   outfontsize:=CanvasToDraw.Font.Size;
   outheight:=((tsD.cy+tsU.cy)div 2); // - (tsD.cy+tsU.cy)div 12
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////
// this is the looong drawing function //
/////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
procedure TForm1.DrawGraph;
var P0, Pt, Pdl, pul : TPoint;
    pointsDL         : array of TPoint;
    pointsUL         : array of TPoint;
    Col              : TColor;
    smax, sDL, sUL   : string;
    quarter, next, calc            : single;
    tsD, tsU                       : TSize;
    i, ip, j, k, l, pointArrSize   : integer;
    start, last, middle, bottom    : integer;
    valD, valU, valD2, valU2       : Integer;
    sum, idiv, dvD, dvU            : integer;
    locgridunit                    : Integer;
    outtype, outfontsize, outheight: integer;
    xcount, combmax                : integer;
    localbFancy                    : boolean;
begin
   if updating then exit;
   bflag:=not bflag;
   localbFancy:=(iFancyState=1) or (iFancyState=2);
   if (form1.Width>MaxWidth div 3) and (form1.Height>Screen.Height div 3) then
     localbFancy:=false;

   // clear all
   CanvasToDraw.Pen.Style:=psSolid;
   CanvasToDraw.Pen.Color:=ColBG;
   CanvasToDraw.Brush.Color:= ColBG;
   CanvasToDraw.Rectangle(0,0,Display.Width, Display.Height);
   SetBkMode(CanvasToDraw.Handle, TRANSPARENT);

   // startup-message + borders
   if (SpeedCounter=0) and (not bfull) then
   begin
     sDL:='...TrafMon starting...';
     tsD:=CanvasToDraw.TextExtent(sDL);
     CanvasToDraw.Brush.Style:=bsSolid;
     CanvasToDraw.Pen.Style:=psSolid;
     ShadowTextOut(CanvasToDraw, ColFont, Display.Width div 2 - tsD.cx div 2, Display.Height div 2 - tsD.cy div 2, sDL);
     CanvasToDraw.Brush.Style:=bsClear;
     CanvasToDraw.Pen.Color:=ColFont;
     CanvasToDraw.Rectangle(0,0,Display.Width,Display.Height);
     CanvasToDraw.Font.Style:=[];
   end;

   if (FormOptions<>nil) and (AdapterItemIndex>=0) and (AdapterItemIndex<FormOptions.Adapter.Items.count) then
     CurrIfObj := TIfObj(FormOptions.Adapter.Items.Objects[AdapterItemIndex]);
   if CurrIfObj=nil then exit;

   start := 0;
   if (Display.Width<SpeedCounter) or bfull then
       start:=SpeedCounter - Display.Width;
   if start < 0 then
         start := MaxWidth + start;
   if start=SpeedCounter then Inc(start);

   maxspeed:=0;
   maxdownspeed:=0;
   maxupspeed:=0;

   // find max
   i:=SpeedCounter;
   if (SpeedCounter>0) or (bfull) then
   while i<>start do
   begin
     valD :=CurrIfObj.SArr[i].DLSpeed;
     valU :=CurrIfObj.SArr[i].ULSpeed;
     if (maxdownspeed < valD) then
     begin
         maxdownspeed:= valD;
         if (maxspeed < maxdownspeed) then
             maxspeed := maxdownspeed;
     end;
     if (maxupspeed   < valU) then
     begin
         maxupspeed:=   valU;
         if (maxspeed < maxupspeed) then
             maxspeed :=maxupspeed;
     end;
     if i=0 then i:=MaxWidth+1;
     Dec(i);
   end;

   if maxspeed=0 then maxspeed := 0.001;
   if maxupspeed=0 then maxupspeed := 0.001;
   if maxdownspeed=0 then maxdownspeed := 0.001;

   if (drawmode=1) or bScaleEqually then begin
      maxupspeed:=maxspeed;
      maxdownspeed:=maxspeed;
   end;

   // tray icon
   if bflag and (SpeedCounter>0) then 
   begin
      // pre-fill icon data
      for i:=0 to 31 do for j:=0 to 31 do bm.Canvas.Pixels[i,j]:=clBlack; // ColBG;

      xcount:=Display.Width-LevelWidth-1;
      i:=speedcounter;
      k:=1;
      while (i<>start) and (xcount+LevelWidth>LevelWidth) and (k<33) do
      begin

          for j:=0 to (trunc(CurrIfObj.SArr[i].DLSpeed/maxspeed*32)) do
            bm.Canvas.Pixels[32-k,32-j]:=ColDLAvg;
          for j:=0 to (trunc(CurrIfObj.SArr[i].ULSpeed/maxspeed*32)) do
            bm.Canvas.Pixels[32-k,32-j]:=ColULAvg;
          if (CurrIfObj.SArr[i].DLSpeed<CurrIfObj.SArr[i].ULSpeed) then
           for j:=0 to (trunc(CurrIfObj.SArr[i].DLSpeed/maxspeed*32)) do
            bm.Canvas.Pixels[32-k,32-j]:=ColComb
          else
           for j:=0 to (trunc(CurrIfObj.SArr[i].ULSpeed/maxspeed*32)) do
            bm.Canvas.Pixels[32-k,32-j]:=ColComb;
          if i=0 then i:=MaxWidth+1;
          Dec(i);
          if xcount<=0 then
            xcount:=MaxWidth+1;
          Dec(xcount,PixelWidth);
          Inc(k);
      end;

      // tooltip
      smax:='- '+Versioninfo +' -'+#13+#10+
            'DL: ' +IntToSize(CurrIfObj.SArr[SpeedCounter].DLSpeed) +'/s'+#13+#10+
            'UL: ' +IntToSize(CurrIfObj.SArr[SpeedCounter].ULSpeed) +'/s';
      // update tray icn
      SetLastError(0);
      DrawBMasIcon(bm, false, smax);
      k:=GetLastError;
   end;

   if not Form1.Visible then exit;
   bdrawing:=true;

   // need to calc the size of the separated area now for correct sizing of canvas
   CanvasToDraw.Font.Size:=FontSize;
   GetSeparatedAreaVars(outtype, outfontsize, outHeight);

   bottom:=Display.Height;
   if bSeparate and (iFontState>0) then bottom:=bottom-outheight+1;
   if bottom<0 then bottom:=0;
   middle:=bottom;
   if drawmode<>1 then middle:=(bottom div 2);

   CanvasToDraw.Font.Name:=FontName;
   if bSeparate and (SpeedCounter>0) then begin
       CanvasToDraw.Brush.Color:=ColSeparate;
       CanvasToDraw.Pen.Style:=psSolid;
       CanvasToDraw.Pen.Color:=ColSeparate;
       CanvasToDraw.Rectangle(0,bottom,Display.Width,Display.Height);
   end;



   // UPLOAD and DOWNLOAD
   xcount:=Display.Width-LevelWidth-1;
   i:=speedcounter;
   if (Display.Height>=outheight) and (Display.Height<bottom+outheight) and
      ((SpeedCounter>0) or (bfull)) then
   while (i<>start) and (xcount+LevelWidth>LevelWidth) do
   begin
       if bAverage then
       begin
         sum:=CurrIfObj.SArr[i  ].DLSpeed+CurrIfObj.SArr[i-1].DLSpeed;
         valD2:=Trunc(middle*((sum/2)/maxdownspeed));
         sum:=CurrIfObj.SArr[i-1].DLSpeed+CurrIfObj.SArr[i-2].DLSpeed;
         valD :=Trunc(middle*((sum/2)/maxdownspeed));

         sum:=CurrIfObj.SArr[i  ].ULSpeed+CurrIfObj.SArr[i-1].ULSpeed;
         valU2:=Trunc(middle*((sum/2)/maxupspeed));
         sum:=CurrIfObj.SArr[i-1].ULSpeed+CurrIfObj.SArr[i-2].ULSpeed;
         valU :=Trunc(middle*((sum/2)/maxupspeed));
       end else begin
         valD2:=Trunc(middle*(CurrIfObj.SArr[i  ].DLSpeed/maxdownspeed));
         valD :=Trunc(middle*(CurrIfObj.SArr[i-1].DLSpeed/maxdownspeed));

         valU2:=Trunc(middle*(CurrIfObj.SArr[i  ].ULSpeed/maxupspeed));
         valU :=Trunc(middle*(CurrIfObj.SArr[i-1].ULSpeed/maxupspeed));
       end;

       if valD2<1 then valD2:=1;
       if valU2<1 then valU2:=1;

       Pdl.X:=xcount; //Display.Width - SpeedCounter*PixelWidth + i*PixelWidth - LevelWidth-1;
       Pul.X:=xcount; //Display.Width - SpeedCounter*PixelWidth + i*PixelWidth - LevelWidth-1;
       Pdl.Y:=middle-valD2;
       if      drawmode=2 then Pul.Y:=middle+valU2
       else if drawmode=0 then Pul.Y:=bottom-valU2-1
                          else Pul.Y:=bottom-valU2;

       // DOWNLOAD
       if bDL then begin
         dvD:=(valD-valD2) div PixelWidth;

         if bFilledGraph then begin
           P0.Y:=middle-1;
           //if drawmode=1 then P0.Y:=P0.Y-1;
           P0.X:=Pdl.X;
         end else begin
           P0.Y:=middle-valD;
           P0.X:=Pdl.X-PixelWidth+1;
           Pdl.Y:=middle-(ValD2);
         end;

         //if P0.Y>Pdl.Y then
         if localbFancy then begin
           DrawLineBresenhamShaded(  CanvasToDraw, P0.X  , P0.Y, Pdl.X  , Pdl.Y                 ,      0, middle, palDownload);
           if bFilledGraph then
             for k:=1 to PixelWidth-1 do
             DrawLineBresenhamShaded(CanvasToDraw, P0.X-k, P0.Y, Pdl.X-k, middle - (ValD2+dvD*k),      0, middle, palDownload);
         end else begin
           DrawLineBresenham(        CanvasToDraw, P0.X  , P0.Y, Pdl.X  , Pdl.Y                 , middle, ColDL);
           if bFilledGraph then
             for k:=1 to PixelWidth-1 do
             DrawLineBresenham(      CanvasToDraw, P0.X-k, P0.Y, Pdl.X-k, middle - (ValD2+dvD*k), middle, ColDL)
         end;
       end;

       // UPLOAD
       if bUL then begin
         if bFilledGraph then begin
           if drawmode=2 then
             P0.Y:=middle+1
           else
             P0.Y:=bottom-1;
           P0.X:=Pul.X;  //
         end else begin
           if drawmode=2 then
             P0.Y:=middle+valU
           else
             P0.Y:=bottom-valU+1;
           P0.X:=Pul.X-PixelWidth;  //
         end;

         dvU:=(valU-valU2) div PixelWidth;
         //if P0.Y>Pul.Y then
         if localbFancy then begin
           if drawmode=1 then
           DrawLineBresenhamShaded(    CanvasToDraw, P0.X  , P0.Y, Pul.X  , Pul.Y,      0, middle, palUpload)
           else if drawmode=2 then
           DrawLineBresenhamShaded(    CanvasToDraw, P0.X  , P0.Y, Pul.X  , Pul.Y, middle, middle, palUpload)
           else
           DrawLineBresenhamShaded(    CanvasToDraw, P0.X  , P0.Y, Pul.X  , Pul.Y, middle, middle, palUpload);
           if bFilledGraph then begin
             for k:=1 to PixelWidth-1 do
               if drawmode=1 then
               DrawLineBresenhamShaded(CanvasToDraw, P0.X-k, P0.Y, Pul.X-k, bottom -        (valU2+dvU*k),      0, bottom, palUpload)
               else if drawmode=2 then
               DrawLineBresenhamShaded(CanvasToDraw, P0.X-k, P0.Y, Pul.X-k, bottom - middle+(valU2+dvU*k), middle, middle, palUpload)
               else
               DrawLineBresenhamShaded(CanvasToDraw, P0.X-k, P0.Y, Pul.X-k, bottom -        (valU2+dvU*k), middle, middle, palUpload);
           end;
         end else begin
           DrawLineBresenham(          CanvasToDraw, P0.X  , P0.Y, Pul.X  , Pul.Y, middle, ColUL);
           if bFilledGraph then begin
             for k:=1 to PixelWidth-1 do
               if drawmode=1 then
               DrawLineBresenham(      CanvasToDraw, P0.X-k, P0.Y, Pul.X-k, bottom -        (valU2+dvU*k), bottom, ColUL)
               else if drawmode=2 then
               DrawLineBresenham(      CanvasToDraw, P0.X-k, P0.Y, Pul.X-k, bottom - middle+(valU2+dvU*k), middle, ColUL)
               else
               DrawLineBresenham(      CanvasToDraw, P0.X-k, P0.Y, Pul.X-k, bottom -        (valU2+dvU*k), middle, ColUL)
           end;
         end;
       end;

       // if overlapping
       if (drawmode=1) and bFilledGraph and bDL and bUL then
       begin
         P0.Y:=bottom-1;
         if bFilledGraph then begin
           if (valD2>valU2) then Pdl.Y:=bottom - valU2
                            else Pdl.Y:=bottom - valD2;
           P0.X:=Pdl.X;
         end else begin
           if (valD2>valU2) then P0.Y:=bottom - valU2
                            else P0.Y:=bottom - valD2;
           P0.X:=Pdl.X-PixelWidth;
         end;

         combmax:=bottom;
         //if drawmode=1 then combmax:=middle;

         dvU:=(valU-valU2) div PixelWidth;
         dvD:=(valD-valD2) div PixelWidth;

         if P0.Y>Pdl.Y then
         if localbFancy then begin
           DrawLineBresenhamShaded(    CanvasToDraw, P0.X  , P0.Y, Pdl.X  ,                  Pdl.Y, 0, combmax, palCombined);
           if bFilledGraph then
             for k:=1 to PixelWidth-1 do
               if (valD2>valU2) then
               DrawLineBresenhamShaded(CanvasToDraw, P0.X-k, P0.Y, Pul.X-k, bottom - (valU2+dvU*k), 0, combmax, palCombined)
               else
               DrawLineBresenhamShaded(CanvasToDraw, P0.X-k, P0.Y, Pul.X-k, bottom - (valD2+dvD*k), 0, combmax, palCombined)
         end else begin
           DrawLineBresenham(          CanvasToDraw, P0.X  , P0.Y, Pdl.X  ,                  Pdl.Y, bottom, ColComb);
           if bFilledGraph then
             for k:=1 to PixelWidth-1 do
               if (valD2>valU2) then
               DrawLineBresenham(      CanvasToDraw, P0.X-k, P0.Y, Pdl.X-k, bottom - (valU2+dvU*k), combmax, ColComb)
               else
               DrawLineBresenham(      CanvasToDraw, P0.X-k, P0.Y, Pdl.X-k, bottom - (valD2+dvD*k), combmax, ColComb)
         end;

       end;

       if i=0 then i:=MaxWidth+1;
       Dec(i);
       if xcount<=0 then
         xcount:=MaxWidth+1;
       Dec(xcount,PixelWidth);
   end; // while for


   (**-)
   // download-average PolyBezier-Version
   if ((SpeedCounter>avg_value) or (bfull)) and bDLAvg then
   begin
     // size for average-array passed to PolyBezier: 4, 7, 10, 13, ...
     if bfull then
     begin
       pointArrSize := (Display.width-LevelWidth) div avg_value;
       pointArrSize := pointArrSize - pointArrSize mod avg_value;
     end else begin
       pointArrSize := speedcounter div avg_value;
       pointArrSize := pointArrSize - pointArrSize mod avg_value;
     end;
     SetLength(PointsDL, pointArrSize+1);

     // startpunkt links
     xcount:=speedcounter*Pixelwidth;
     if bfull then xcount:=Display.Width * PixelWidth - ((avg_value-(speedcounter mod avg_value))*Pixelwidth);
     i:=start;
     if bfull then i:=start - (speedcounter mod avg_value);
     P0.X:=Display.Width - xcount - LevelWidth;
     P0.Y:=middle;
     PointsDL[0]:=P0;

     while xcount>avg_value do
     begin
       calc:=CurrIfObj.SArr[i].DLSpeed;
       for j:=i+1 to i+avg_value do
         calc:=(calc+(CurrIfObj.SArr[j].DLSpeed))/2;
       P0.X:=Display.Width - xcount - LevelWidth;
       P0.Y:=middle - Trunc(middle * calc/maxdownspeed )-1;
       Inc(ip);
       if (ip>High(PointsDL)) then break;
       PointsDL[ip]:=P0;
       Dec(xcount,Pixelwidth*avg_value);
     end;

     //PointsDL[High(PointsDL)].X:=Display.Width - LevelWidth;
     //PointsDL[High(PointsDL)].Y:=middle - Trunc(middle*CurrIfObj.SArr[SpeedCounter].DLSpeed/maxdownspeed)-1;
     //if drawmode=1 then PointsDL[High(PointsDL)].Y:=PointsDL[High(PointsDL)].Y-1;
     CanvasToDraw.Pen.Color:=ColDLAvg;
     CanvasToDraw.PolyBezier(PointsDL);
   end;
   (**)

   (**)
   // download-average LineTo-Version
   if (Display.Height>=outheight) and (Display.Height<bottom+outheight) then
   if ((SpeedCounter>avg_value) or (bfull)) and bDLAvg then
   begin
     CanvasToDraw.Pen.Color:=ColDLAvg;
     // startpunkt links
     xcount:=speedcounter*Pixelwidth;
     if bfull then xcount:=Display.Width * PixelWidth -
                           ((avg_value-(speedcounter mod avg_value))*Pixelwidth) + avg_value*Pixelwidth;
     i:=0;
     if bfull then i:=start - (speedcounter mod avg_value);

     CanvasToDraw.MoveTo(Display.Width - xcount - LevelWidth, middle);

     while xcount+LevelWidth>LevelWidth+PixelWidth do
     begin
       calc:=CurrIfObj.SArr[i].DLSpeed;
       for j:=i+1 to i+avg_value do
         if CurrIfObj.SArr[j].DLSpeed<>0 then
           calc:=(calc+(CurrIfObj.SArr[j].DLSpeed))/2;

       CanvasToDraw.LineTo(Display.Width - xcount - LevelWidth,
                           middle - Trunc(middle * calc/maxdownspeed ));
       Inc(i,avg_value);
       if i>=MaxWidth then i:=0;
       Dec(xcount,Pixelwidth*avg_value);
     end;

     // endpunkt rechts
     p0.Y:=middle - Trunc(middle * CurrIfObj.SArr[SpeedCounter].DLSpeed/maxdownspeed );
     //if drawmode<>2 then p0.Y:=p0.Y+2;
     CanvasToDraw.LineTo(Display.Width - LevelWidth,p0.y);
     {} // tendency
     if CurrIfObj.SArr[SpeedCounter].DLSpeed<CurrIfObj.SArr[SpeedCounter-1].DLSpeed then begin
       DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,middle-valD2-1, FALSE, ColShadow);
       DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,middle-valD2+1, FALSE, ColShadow);
       DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,middle-valD2  , FALSE, ColDLAvg);
     end else begin
       DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,middle-valD2-1, TRUE, ColShadow);
       DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,middle-valD2+1, TRUE, ColShadow);
       DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,middle-valD2  , TRUE, ColDLAvg);
     end;
     {}
   end;
   (**)

   // upload-average
   if (Display.Height>=outheight) and (Display.Height<bottom+outheight) then
   if ((SpeedCounter>avg_value) or (bfull)) and bULAvg then
   begin
     CanvasToDraw.Pen.Color:=ColULAvg;
     // startpunkt links
     xcount:=speedcounter*Pixelwidth;
     if bfull then xcount:=Display.Width * PixelWidth -
                           ((avg_value-(speedcounter mod avg_value))*Pixelwidth) + avg_value*Pixelwidth - 1;
     i:=0;
     if bfull then i:=start - (speedcounter mod avg_value);

     if drawmode=2 then
     CanvasToDraw.MoveTo(Display.Width - xcount - LevelWidth, middle+1)
     else
     CanvasToDraw.MoveTo(Display.Width - xcount - LevelWidth, bottom);

     while (xcount+LevelWidth>LevelWidth+PixelWidth) do
     begin
       calc:=CurrIfObj.SArr[i].ULSpeed;
       for j:=i+1 to i+avg_value do
         if CurrIfObj.SArr[j].ULSpeed<>0 then
           calc:=(calc+(CurrIfObj.SArr[j].ULSpeed))/2;

       if drawmode<>2 then
       p0.y:=bottom - Trunc(middle * calc/maxupspeed )
       else
       p0.y:=middle + Trunc(middle * calc/maxupspeed )+1;
       CanvasToDraw.LineTo(Display.Width - xcount - LevelWidth,p0.y);
       Inc(i,avg_value);
       if i>=MaxWidth then i:=0;
       Dec(xcount,Pixelwidth*avg_value);
     end;

     // endpunkt rechts
     if drawmode<>2 then
       p0.Y:=bottom - Trunc(middle * CurrIfObj.SArr[SpeedCounter].ULSpeed/maxupspeed )
     else
       p0.Y:=middle + Trunc(middle * CurrIfObj.SArr[SpeedCounter].ULSpeed/maxupspeed );
     if drawmode=0 then
       p0.Y:=p0.Y+2;
     CanvasToDraw.LineTo(Display.Width - LevelWidth,p0.Y);

      (**-)
      SetLength(PointsUL, pointArrSize+1);
      ip:=0;
      PointsUL[ip].X:=Display.Width - speedcounter*PixelWidth + PixelWidth - LevelWidth+1;
      if drawmode=0 then
        PointsUL[ip].Y:=bottom-Trunc(middle*CurrIfObj.SArr[0].ULSpeed/maxupspeed)-1
      else if drawmode=1 then
        PointsUL[ip].Y:=middle-Trunc(middle*CurrIfObj.SArr[0].ULSpeed/maxupspeed)-1
      else
        PointsUL[ip].Y:=middle+Trunc(middle*CurrIfObj.SArr[0].ULSpeed/maxupspeed)+1;
      i:=0;

      while (i+avg_value+1 < speedcounter) do begin
          calc:=CurrIfObj.SArr[i].ULSpeed;
          for j:=i+1 to i+avg_value do
            calc:=(calc+CurrIfObj.SArr[j].ULSpeed)/2;
          P0.X:=Display.Width - speedcounter*PixelWidth + i*PixelWidth + avg_value-LevelWidth;
          if drawmode=0 then
            P0.Y:=bottom - Trunc(middle * (calc / maxupspeed))-1
          else if drawmode=1 then
            P0.Y:=middle - Trunc(middle * (calc / maxupspeed))-1
          else
            P0.Y:=middle + Trunc(middle * (calc / maxupspeed))+1;
          Inc(ip);
          if (ip>High(PointsUL)) then break;
          PointsUL[ip]:=P0;
          Inc(i,avg_value);
      end;

      PointsUL[High(PointsUL)].X:=Display.Width-LevelWidth;
      if drawmode=0 then
        PointsUL[High(PointsUL)].Y:=bottom - Trunc(middle * ( CurrIfObj.SArr[SpeedCounter].ULSpeed / maxupspeed))-1
      else if drawmode=1 then
        PointsUL[High(PointsUL)].Y:=middle - Trunc(middle * ( CurrIfObj.SArr[SpeedCounter].ULSpeed / maxupspeed))-1
      else
        PointsUL[High(PointsUL)].Y:=middle + Trunc(middle * ( CurrIfObj.SArr[SpeedCounter].ULSpeed / maxupspeed))+1;
      CanvasToDraw.PolyBezier(PointsUL);
      (**)

      (*tendency*-)
      if CurrIfObj.SArr[SpeedCounter].ULSpeed<CurrIfObj.SArr[SpeedCounter-1].ULSpeed then begin
        DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,bottom-valU2-1, FALSE, ColShadow);
        DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,bottom-valU2+1, FALSE, ColShadow);
        DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,bottom-valU2  , FALSE, ColULAvg);
      end else begin
        DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,bottom-valU2-1, TRUE, ColShadow);
        DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,bottom-valU2+1, TRUE, ColShadow);
        DrawUpDown(CanvasToDraw, Display.Width-LevelWidth-3,bottom-valU2  , TRUE, ColULAvg);
      end;
      (**)
   end;

   // right-side-level-meter
   if (Display.Height>=outheight) and (Display.Height<bottom+outheight) then
   if (SpeedCounter>0) or bfull then
   begin
      CanvasToDraw.Pen.Color:=ColComb;
      CanvasToDraw.Brush.Color:=ColComb;
      valD:=Trunc(middle*(CurrIfObj.SArr[SpeedCounter].DLSpeed/maxdownspeed));
      valU:=Trunc(middle*(CurrIfObj.SArr[SpeedCounter].ULSpeed/maxupspeed));
      if valu>middle then
        DrawShadedRectangle(CanvasToDraw, 10,10,15,15,25,50,palCombined);
      if bFilledGraph then begin
        if drawmode=1 then begin
          if (valD>valU) then begin
            if localbFancy then begin
              DrawShadedRectangle(CanvasToDraw, Display.Width, bottom-valD+1, Display.Width-LevelWidth, bottom-valU  , 0, bottom, palDownload);
              DrawShadedRectangle(CanvasToDraw, Display.Width, bottom-valU+1, Display.Width-LevelWidth, bottom     -2, 0, bottom, palCombined);
            end else begin
              CanvasToDraw.Rectangle(Display.Width, bottom   , Display.Width-LevelWidth, bottom-valU);
              CanvasToDraw.Pen.Color:=ColDLAvg;
              CanvasToDraw.Brush.Color:=ColDLAvg;
              CanvasToDraw.Rectangle(Display.Width, bottom-valU, Display.Width-LevelWidth, bottom-valD);
              CanvasToDraw.Pen.Color:=ColULAvg;
              CanvasToDraw.Brush.Color:=ColULAvg;
              P0.Y:=bottom-valU;
            end;
          end else begin
            if localbFancy then begin
              DrawShadedRectangle(CanvasToDraw, Display.Width-LevelWidth, bottom-valD+1, Display.Width, bottom     -2, 0, bottom, palCombined);
              DrawShadedRectangle(CanvasToDraw, Display.Width-LevelWidth, bottom-valU+1, Display.Width, bottom-valD  , 0, bottom, palUpload);
            end else begin
              CanvasToDraw.Rectangle(Display.Width, bottom   , Display.Width-LevelWidth, bottom-valD  );
              CanvasToDraw.Pen.Color:=ColULAvg;
              CanvasToDraw.Brush.Color:=ColULAvg;
              CanvasToDraw.Rectangle(Display.Width, bottom-valD, Display.Width-LevelWidth, bottom-valU-1);
              CanvasToDraw.Pen.Color:=ColDLAvg;
              CanvasToDraw.Brush.Color:=ColDLAvg;
              P0.Y:=bottom-valD;
              P0.X:=Display.Width-LevelWidth;
              CanvasToDraw.PenPos:=P0;
              CanvasToDraw.LineTo(P0.X+LevelWidth, P0.Y);
            end;
          end;
        end else begin
          if localbFancy then begin
            DrawShadedRectangle(CanvasToDraw  , Display.Width-LevelWidth, middle-valD+1, Display.Width, middle     -1,      0, middle, palDownload);
            if drawmode=2 then
              DrawShadedRectangle(CanvasToDraw, Display.Width-LevelWidth, middle     +1, Display.Width, middle+valU+1, middle, middle, palUpload)
            else
              DrawShadedRectangle(CanvasToDraw, Display.Width-LevelWidth, bottom-valU+1, Display.Width, bottom     -2, middle, middle, palUpload);
          end else begin
            CanvasToDraw.Pen.Color:=ColDLAvg;
            CanvasToDraw.Brush.Color:=ColDLAvg;
            CanvasToDraw.Rectangle(Display.Width  , middle-valD, Display.Width-LevelWidth, middle       );

            CanvasToDraw.Pen.Color:=ColULAvg;
            CanvasToDraw.Brush.Color:=ColULAvg;
            if drawmode=2 then
              CanvasToDraw.Rectangle(Display.Width, middle+1, Display.Width-LevelWidth, middle+valU)
            else
              CanvasToDraw.Rectangle(Display.Width, bottom-1, Display.Width-LevelWidth, bottom-valU+2)
          end;
        end;
      end;
   end;

   CanvasToDraw.Font.Style:=[];
   CanvasToDraw.Pen.Style:=psSolid;
   // peaks of level-meter
   if (Display.Height>=outheight) and (Display.Height<bottom+outheight) then
   if SpeedCounter>0 then begin
     CanvasToDraw.Pen.Color:=ColDLAvg;
     P0.X:=Display.Width-LevelWidth;
     P0.Y:=middle-valD;
     if not bFilledGraph then if (drawmode=1) then P0.Y:=P0.Y-1;
     CanvasToDraw.PenPos:=P0;
     P0.X:=Display.Width;
     CanvasToDraw.LineTo(P0.X, P0.Y);

     CanvasToDraw.Pen.Color:=ColULAvg;
     P0.X:=Display.Width-LevelWidth;
     if drawmode=2 then
       P0.Y:=middle+valU
     else if drawmode=0 then
       P0.Y:=bottom-valU+2
     else
       P0.Y:=bottom-valU;
     CanvasToDraw.PenPos:=P0;
     P0.X:=Display.Width;
     CanvasToDraw.LineTo(P0.X, P0.Y);
   end;

   CanvasToDraw.Brush.Style:=bsClear;
   CanvasToDraw.Pen.Style:=psSolid;
   SetBkMode(CanvasToDraw.Handle, TRANSPARENT);

   // grid-unit lines and values
   //if (Display.Height<bottom+outheight) then
   if (Display.Height>=outheight) and (Display.Height<bottom+outheight) then
   if (bGridunits) and (bottom>15) and (SpeedCounter>0) then begin
      CanvasToDraw.Pen.Color:=ColGrid;
      CanvasToDraw.Pen.Style:=psDot;
      CanvasToDraw.Font.Color:=ColGrid;
      CanvasToDraw.Font.Size:=Fontsize-3;
      if CanvasToDraw.Font.Size>8 then
          CanvasToDraw.Font.Size:=8;

      if (maxdownspeed > 0) then begin
         // grid lines obere hlfte
         j:=0;
         next:=0;
         last:=middle;
         quarter := middle/(maxdownspeed/1024);

         locgridunit:=gridunit div 1024;
         if quarter<1 then
            locgridunit:=Trunc((maxdownspeed/1024)/20);
         if locgridunit<gridunit then
            locgridunit:=gridunit;

         Pdl.X:=1;
         Pul.X:=Display.Width-1;
         for i:=0 to middle-1 do begin
            Pdl.Y:=middle-i;
            Pul.Y:=Pdl.Y;
            next:=next + 1;
            if (next>=quarter*locgridunit) then begin
                Inc(j);
                if (last-11>Pdl.Y) and (Pdl.Y>=0) then begin
                  CanvasToDraw.PenPos:=Pdl;
                  CanvasToDraw.LineTo(Pul.X, Pul.Y);
                  if (iFontState=1) then begin
                    //sDL:=IntToStr(j*locgridunit)+'k';
                    sDL:=IntToSizeShort(j*locgridunit*1024);
                    //sDL:=IntToSizeShort((i/maxupspeed)*(maxupspeed/1024));
                    tsD:=CanvasToDraw.TextExtent(sDL);
                    CanvasToDraw.TextOut(Display.Width-tsD.cx-1, Pul.Y-1, sDL);
                  end;
                  last:=Pdl.Y;
                end;
                next:=0;
            end;
         end;


         // grid lines untere hlfte
         if drawmode=0 then begin
         j:=0;
         next:=0;
         last:=bottom;
         quarter := middle/(maxupspeed/1024);

         locgridunit:=gridunit;
         if quarter<1 then
            locgridunit:=Trunc((maxdownspeed/1024)/20);
         if locgridunit<gridunit then
            locgridunit:=gridunit;

         Pdl.X:=1;
         Pul.X:=Display.Width-1;
         for i:=bottom downto middle do begin
            Pdl.Y:=i;
            Pul.Y:=bottom-middle+i;
            next:=next + 1;
            if (next>=quarter*locgridunit) then begin
                Inc(j);
                if (Pdl.Y<last-11) and (Pdl.Y>middle) then
                begin
                  CanvasToDraw.PenPos:=Pdl;
                  CanvasToDraw.LineTo(Pul.X, i);
                  if (iFontState=1) then begin
                    //sUL:=IntToStr(j*locgridunit)+'k';
                    sUL:=IntToSizeShort(j *locgridunit*1024);
                    //sUL:=IntToSizeShort((i/middle)*(maxupspeed/1024));
                    tsU:=CanvasToDraw.TextExtent(sUL);
                    CanvasToDraw.TextOut(Display.Width-tsU.cx-1, Pul.Y-middle-1, sUL);
                  end;
                  last:=Pdl.Y;
                end;
                next:=0;
            end;
         end;
         end else if drawmode=2 then begin
         j:=0;
         next:=0;
         last:=middle;
         quarter := middle/(maxupspeed/1024);

         locgridunit:=gridunit;
         if quarter<1 then
            locgridunit:=Trunc((maxdownspeed/1024)/20);
         if locgridunit<gridunit then
            locgridunit:=gridunit;

         Pdl.X:=1;
         Pul.X:=Display.Width-1;
         for i:=middle to bottom do begin
            Pdl.Y:=i;
            Pul.Y:=Pdl.Y;
            next:=next + 1;
            if (next>=quarter*locgridunit) then begin
                Inc(j);
                if (Pdl.Y>last+11) and (Pdl.Y<bottom) then begin
                  CanvasToDraw.PenPos:=Pdl;
                  CanvasToDraw.LineTo(Pul.X, i);
                  if (iFontState=1) then begin
                    //sUL:=IntToStr(j*locgridunit)+'k';
                    sUL:=IntToSizeShort(j*locgridunit*1024);
                    //sUL:=IntToSizeShort((i/middle)*(maxupspeed/1024));
                    tsU:=CanvasToDraw.TextExtent(sUL);
                    CanvasToDraw.TextOut(Display.Width-tsU.cx-1, Pul.Y-tsU.cy, sUL);
                  end;
                  last:=Pdl.Y;
                end;
                next:=0;
            end;
         end;
         end;
      end;
   end;

   (*
   if (not bBorderLines) and (drawmode<>1) and not (bBG) then begin
       CanvasToDraw.Pen.Color:=Darker(ColDL, middle div 4, middle);
       P0.X:=Display.Width-LevelWidth-SpeedCounter*PixelWidth;
       P0.Y:=middle;
       CanvasToDraw.PenPos:=P0;
       CanvasToDraw.LineTo(Display.Width, middle);

       CanvasToDraw.Pen.Color:=Darker(ColUL, middle div 4, middle);
       P0.Y:=bottom-1;
       CanvasToDraw.PenPos:=P0;
       CanvasToDraw.LineTo(Display.Width, bottom-1);
   end;
   *)

   // obere und untere Linien
   CanvasToDraw.Pen.Style:=psSolid;
   if (Display.Height>=outheight) and (Display.Height<bottom+outheight) then
   if (iBorderLines=1) and (SpeedCounter>0) then begin
      CanvasToDraw.Pen.Color:=ColBorder;
      // oben
      P0.X:=0; P0.Y:=0;
      CanvasToDraw.PenPos:=P0;
      CanvasToDraw.LineTo(Display.Width, 0);
      // unten
      P0.Y:=bottom-1;
      CanvasToDraw.PenPos:=P0;
      CanvasToDraw.LineTo(Display.Width, bottom-1);
      if bSeparate then begin
        P0.Y:=Display.Height-1;
        CanvasToDraw.PenPos:=P0;
        CanvasToDraw.LineTo(Display.Width, Display.Height-1);
      end;
      // mitte
      if drawmode<>1 then begin
        P0.Y:=middle;
        CanvasToDraw.PenPos:=P0;
        CanvasToDraw.LineTo(Display.Width, middle);
      end;
   end else if (speedcounter>0) and (iBorderLines=2) then begin
        CanvasToDraw.Pen.Color:=Darker(ColBorder,63, 64);
        //CanvasToDraw.Pen.Color:=Darker(ColBorder,(middle div 2) + (middle div 3) + (middle div 4), middle);
        P0.X:=Display.Width-LevelWidth-SpeedCounter*PixelWidth;
        P0.Y:=middle;
        CanvasToDraw.PenPos:=P0;
        CanvasToDraw.LineTo(Display.Width, middle);
        P0.X:=0;
        // oben
        P0.Y:=0;
        CanvasToDraw.PenPos:=P0;
        CanvasToDraw.LineTo(Display.Width, 0);
        // unten
        P0.Y:=bottom-1;
        CanvasToDraw.PenPos:=P0;
        CanvasToDraw.LineTo(Display.Width, bottom-1);
   end;

   // right-side-level-meter-border
   if (Display.Height>=outheight) and (Display.Height<bottom+outheight) then
   if (LevelWidth>0) and ((speedcounter>0) or bfull) then begin
     if (iBorderLines=2) then begin
       if drawmode=1 then CanvasToDraw.Pen.Style:=psDot;
       CanvasToDraw.Pen.Color:=Darker(ColDL, middle div 2, middle);
       P0.X:=Display.Width-LevelWidth;
       P0.Y:=0;
       CanvasToDraw.PenPos:=P0;
       CanvasToDraw.LineTo(P0.X, middle);
       CanvasToDraw.Pen.Color:=Darker(ColUL, middle div 2, middle);
       if drawmode=1 then P0.Y:=1 else P0.Y:=middle;
       CanvasToDraw.PenPos:=P0;
       CanvasToDraw.LineTo(P0.X, bottom);
     end else if (iBorderLines=1) then begin
       CanvasToDraw.Pen.Color:=ColBorder;
       CanvasToDraw.Brush.Color:=ColBorder;
       P0.X:=Display.Width-LevelWidth;
       P0.Y:=0;
       CanvasToDraw.PenPos:=P0;
       CanvasToDraw.LineTo(P0.X, bottom);
     end;
   end;

   if bBold then CanvasToDraw.Font.Style:=[fsbold]
            else CanvasToDraw.Font.Style:=[];
     CanvasToDraw.Font.Size:=8;

   // max and curr DL and UL kb/s
   if (iFontState>0) and (SpeedCounter>0) then
   begin
      CanvasToDraw.Pen.Color:=ColGrid;
      CanvasToDraw.Font.Color:=ColFont;
      CanvasToDraw.Font.Size:=FontSize-2;
      if CanvasToDraw.Font.Size>8 then
        CanvasToDraw.Font.Size:=8;
      CanvasToDraw.Brush.Style:=bsClear;

      if (bottom>24) and (iFontState=1) then begin
        // DL-max
        smax:=IntToSizeShort(maxdownspeed)+' max';
        tsD:=CanvasToDraw.TextExtent(smax);
        if bSeparate then begin
          if not bScaleEqually then begin
            if tsD.cx>middle-4 then begin
              smax:=IntToSizeShort(maxdownspeed);
              tsD:=CanvasToDraw.TextExtent(smax);
            end;
            if tsD.cx>middle then begin
              smax:=IntToSizeNoSize(maxdownspeed);
              tsD:=CanvasToDraw.TextExtent(smax);
            end;
          end else begin
            if tsD.cx>bottom-4 then begin
              smax:=IntToSizeShort(maxdownspeed);
              tsD:=CanvasToDraw.TextExtent(smax);
            end;
            if tsD.cx>bottom then begin
              smax:=IntToSizeNoSize(maxdownspeed);
              tsD:=CanvasToDraw.TextExtent(smax);
            end;
          end;

          CanvasToDraw.Brush.Color:=ColSeparate;
          CanvasToDraw.Pen.Color:=ColSeparate;
          if (bScaleEqually) then
            CanvasToDraw.Rectangle(0,1,tsD.cy,bottom-1)
          else
            if drawmode=1 then
              CanvasToDraw.Rectangle(0,1,tsD.cy,middle-1)
            else
              CanvasToDraw.Rectangle(0,1,tsD.cy,middle);
          VerticalTextOut(CanvasToDraw, -2, tsD.cx+3, smax);
        end else
          //middle-valD or 1
          CanvasToDraw.TextOut(SeparateWidth+1, 1, smax);

        // UL-max
        if (drawmode<>1) and (iFontState=1) and (not bScaleEqually) then begin
          smax:=IntToSizeShort(maxupspeed)+' max';
          tsU:=CanvasToDraw.TextExtent(smax);
          if bSeparate then begin
            CanvasToDraw.Brush.Color:=ColSeparate;
            CanvasToDraw.Pen.Style:=psSolid;
            CanvasToDraw.Pen.Color:=ColSeparate;
            CanvasToDraw.Rectangle(0,middle+1,tsD.cy,bottom-1);
            if tsD.cx>middle-4 then begin
              smax:=IntToSizeShort(maxupspeed);
              tsD:=CanvasToDraw.TextExtent(smax);
            end;
            if tsD.cx>middle then begin
              smax:=IntToSizeNoSize(maxupspeed);
              tsD:=CanvasToDraw.TextExtent(smax);
            end;
            if drawmode<>2 then
            VerticalTextOut(CanvasToDraw, -2, middle+tsD.cx+3, smax)
            else
            VerticalTextOut(CanvasToDraw, -2, bottom-3, smax)
          end else begin
            if drawmode=2 then
            CanvasToDraw.TextOut(1, bottom-tsD.cy - 1, smax)
            else
            CanvasToDraw.TextOut(1, middle        + 1, smax);
          end;
        end;
      end;

      // curr DL and UL
      CanvasToDraw.Font.Size:=outfontsize;
      if bBold then CanvasToDraw.Font.Style:=[fsbold]
               else CanvasToDraw.Font.Style:=[];
      SetBkMode(CanvasToDraw.Handle, TRANSPARENT);

      GetSeparatedAreaVars(outtype, outfontsize, outHeight);
      SetTextByIndex(outtype, sDL, sUL);
      //CanvasToDraw.Pen.Style:=psClear;

      if bSeparate then begin
            tsD:=CanvasToDraw.TextExtent(sDL+' '+sUL);
            // curr DL
            if bValuesInColor then Col:=ColDLAvg else Col:=ColFont;
            ShadowTextOut(CanvasToDraw, Col, Display.Width div 2 - (tsD.cx div 2) - 6, Display.Height-tsD.cy, sDL);
            // curr UL
            if bValuesInColor then Col:=ColULAvg else Col:=ColFont;
            ShadowTextOut(CanvasToDraw, Col, Display.Width div 2                  + 6, Display.Height-tsD.cy, sUL);
      end else begin
        if drawmode<>1 then begin
            // tiled mode
            tsD:=CanvasToDraw.TextExtent(sDL+' ');
            tsU:=CanvasToDraw.TextExtent(sUL+' ');
            // curr DL
            if bValuesInColor then Col:=ColDLAvg else Col:=ColFont;
            ShadowTextOut(CanvasToDraw,Col,SeparateWidth+1, middle-tsd.cy, sDL);

            // curr UL
            if bValuesInColor then Col:=ColULAvg else Col:=ColFont;
            if drawmode=2 then begin
              ShadowTextOut(CanvasToDraw, Col, SeparateWidth+1, middle, sUL)
            end else begin
              ShadowTextOut(CanvasToDraw, Col, SeparateWidth+1, bottom-tsu.cy, sUL)
            end;
        end else if drawmode=1 then begin
            // single mode
            // curr DL
            smax:=sDL;
            tsD:=CanvasToDraw.TextExtent(smax);
            if bValuesInColor then Col:=ColDLAvg else Col:=ColFont;
            ShadowTextOut(CanvasToDraw, Col, Display.Width div 2 - tsD.cx - 2, bottom-tsD.cy - 1, smax);
            // curr UL
            smax:=sUL;
            tsD:=CanvasToDraw.TextExtent(smax);
            if bValuesInColor then Col:=ColULAvg else Col:=ColFont;
            ShadowTextOut(CanvasToDraw, Col, Display.Width div 2          + 2, bottom-tsD.cy - 1, smax);
        end;
      end;
   end;

   // palette output
   (**-)
   DrawShadedRectangle(CanvasToDraw, 40,      1, 43, bottom-1, bottom-1, palCombined);
   DrawShadedRectangle(CanvasToDraw, 44,      1, 47, bottom-1, bottom-1, palDownload);
   DrawShadedRectangle(CanvasToDraw, 48,      1, 51, bottom-1, bottom-1, palUpload);
   DrawShadedRectangle(CanvasToDraw, 52, middle, 55, bottom-1, bottom-1, palCombined);
   DrawShadedRectangle(CanvasToDraw, 56, middle, 59, bottom-1, bottom-1, palDownload);
   DrawShadedRectangle(CanvasToDraw, 60, middle, 63, bottom-1, bottom-1, palUpload);
   *)
   (**-)
   // or this
   for i:=0 to (middle-1) do begin
     ip := Round(i/middle*middle);
     for j:=Display.Width-1 downto display.Width-6 do CanvasToDraw.Pixels[j,i]:=palDownload[ip];
     for j:=Display.Width-7 downto display.Width-12 do CanvasToDraw.Pixels[j,i]:=palUpload[ip];
     for j:=Display.Width-13 downto display.Width-18 do CanvasToDraw.Pixels[j,i]:=palCombined[ip];
   end;
   (**)


   bdrawn:=true;
   bdrawing:=false;
   CanvasToDraw.Font.Style:=[];
   //CanvasToDraw.TextOut(100, 15, inttostr(speedcounter));
   //SetBkMode(CanvasToDraw.Handle, TRANSPARENT);
   BitBlt(Form1.Canvas.Handle,0,0,Form1.ClientWidth,Form1.ClientHeight,
          CanvasToDraw.Handle,0,0,SRCCOPY);
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.DeletePeaks;
var i, j : Integer;
    localmaxd, localmaxu: single;
    imaxd, imaxu: Integer;
    imaxd2, imaxu2: Integer;
    IfObj:TIfObj;
    i1,i2:integer;
    diffdl,difful:cardinal;
    start:integer;
begin
    localmaxd:=0; imaxd:=0; imaxd2:=0;
    localmaxu:=0; imaxu:=0; imaxu2:=0;

    i1:=AdapterItemIndex;
    i2:=AdapterItemIndex;
    if AdapterItemIndex=0 then
       i2:=FormOptions.Adapter.Items.Count-1;

    start := 0;
    if (Display.Width<SpeedCounter) or bfull then
       start:=SpeedCounter - Display.Width;
    if start < 0 then
          start := MaxWidth + start;
    if start=SpeedCounter then Inc(start);

    for j := i1 to i2 do
    begin

      IfObj:=TIfObj(FormOptions.Adapter.Items.Objects[j]);

      //for i:=Screen.Width downto 0 do
      i:=SpeedCounter;
      if (SpeedCounter>0) or (bfull) then
      while i<>start do
      begin
        diffdl:=CurrIfObj.SArr[i].DLSpeed;
        difful:=CurrIfObj.SArr[i].ULSpeed;
        if (localmaxd < diffdl) then begin imaxd2:=imaxd; imaxd:=i; localmaxd:=diffdl; end;
        if (localmaxu < difful) then begin imaxu2:=imaxu; imaxu:=i; localmaxu:=difful; end;
        if i=0 then i:=MaxWidth+1;
        Dec(i);
      end;

      if maxspeed<0.1 then exit;

      // average down the max
      if imaxd>0 then
      if imaxd=speedcounter-1 then begin
          IfObj.SArr[imaxd].DLSpeed:=(IfObj.SArr[imaxd  ].DLSpeed + IfObj.SArr[imaxd-1].DLSpeed) div 2;
      end else begin
        if imaxd>0 then
          IfObj.SArr[imaxd].DLSpeed:=(IfObj.SArr[imaxd  ].DLSpeed +
                                      IfObj.SArr[imaxd-1].DLSpeed +
                                      IfObj.SArr[imaxd+1].DLSpeed   ) div 3
        else
          IfObj.SArr[imaxd].DLSpeed:=(IfObj.SArr[imaxd  ].DLSpeed + IfObj.SArr[imaxd-1].DLSpeed) div 2;
      end;

      if imaxu>0 then
      if imaxu=speedcounter-1 then begin
          IfObj.SArr[imaxu].ULSpeed:=(IfObj.SArr[imaxu  ].ULSpeed + IfObj.SArr[imaxu-1].ULSpeed) div 2;
      end else begin
        if imaxu>0 then
          IfObj.SArr[imaxu].ULSpeed:=(IfObj.SArr[imaxu  ].ULSpeed +
                                      IfObj.SArr[imaxu+1].ULSpeed +
                                      IfObj.SArr[imaxu-1].ULSpeed   ) div 3
        else
          IfObj.SArr[imaxu].ULSpeed:=(IfObj.SArr[imaxu  ].ULSpeed + IfObj.SArr[imaxu-1].ULSpeed) div 2;
      end;

      if imaxd2>0 then
      if imaxd2=speedcounter-1 then begin
          IfObj.SArr[imaxd2].DLSpeed:=(IfObj.SArr[imaxd2  ].DLSpeed + IfObj.SArr[imaxd2-1].DLSpeed) div 2;
      end else begin
        if imaxd2>0 then
          IfObj.SArr[imaxd2].DLSpeed:=(IfObj.SArr[imaxd2  ].DLSpeed +
                                      IfObj.SArr[imaxd2-1].DLSpeed +
                                      IfObj.SArr[imaxd2+1].DLSpeed   ) div 3
        else
          IfObj.SArr[imaxd2].DLSpeed:=(IfObj.SArr[imaxd2  ].DLSpeed + IfObj.SArr[imaxd2-1].DLSpeed) div 2;
      end;

      if imaxu2>0 then
      if imaxu2=speedcounter-1 then begin
          IfObj.SArr[imaxu2].ULSpeed:=(IfObj.SArr[imaxu2  ].ULSpeed + IfObj.SArr[imaxu2-1].ULSpeed) div 2;
      end else begin
        if imaxu2>0 then
          IfObj.SArr[imaxu2].ULSpeed:=(IfObj.SArr[imaxu2  ].ULSpeed +
                                      IfObj.SArr[imaxu2+1].ULSpeed +
                                      IfObj.SArr[imaxu2-1].ULSpeed   ) div 3
        else
          IfObj.SArr[imaxu2].ULSpeed:=(IfObj.SArr[imaxu2  ].ULSpeed + IfObj.SArr[imaxu2-1].ULSpeed) div 2;
      end;

    end;
    DrawGraph;
end;

procedure TForm1.displaypopupPopup(Sender: TObject);
begin
  displaypopup.tag:=0;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TForm1.varinfo(y:integer; info:string);
var P : TPoint;
begin
  P:=CanvasToDraw.PenPos; // save
  CanvasToDraw.Font.Color:=clSilver;
  CanvasToDraw.Brush.Color:=clBlack;
  CanvasToDraw.pen.Color:=clBlack;
  CanvasToDraw.Rectangle(10,ClientHeight-50-y,50,ClientHeight-50-y+15);
  CanvasToDraw.TextOut(10, ClientHeight-50-y, info);
  CanvasToDraw.PenPos:=P; // setback
end;


procedure TForm1.UpdateInterfaces;
var MibRow                    : TMibIfRow;
    IntfTable                 : PMibIfTable;
    mitcpstats:MIB_TCPSTATS;
    miipstats:MIB_IPSTATS;
    miicmp:MIB_ICMP;
    InOct, OutOct             : Cardinal;
    Size                      : Cardinal;
    AdpIdx, AdpNum, I, J, K   : integer;
    adapterdescr,sIn,sOut     : string;
    bAdded                    : boolean;
    timediffcurr:Cardinal;
begin
  InOct := 0;
  OutOct:= 0;
  Size  := 0;
  timecurr:=GetTickCount;
  timediffcurr:=timecurr-timelast;
  timelast:=timecurr;

  if timediffcurr>10*Timer1.Interval then
  begin
      //lastInOct            := InOct;
      //lastOutOct           := OutOct;
      exit;
  end;
  if timediffcurr=0 then timediffcurr:=Timer1.Interval;

  if globalX = 0 then begin
      // first time - set to current values
      lastInOct            := InOct;
      lastOutOct           := OutOct;
      WSessDL              := InOct;
      WSessUL              := OutOct;
  end;

  // get IntfTable-size
  if GetIfTable(nil, Size, True) <> ERROR_INSUFFICIENT_BUFFER then Exit;
  // alloc mem for IntfTable
  IntfTable := AllocMem(Size);
  try
    // get IntfTable-data
    if GetIfTable(IntfTable, Size, True) = NO_ERROR then
    begin
        if IntfTable^.dwNumEntries>0 then
        begin
            // loop all interfaces and get their data
            for I := 0 to IntfTable^.dwNumEntries - 1 do
            begin
                {$R-} MibRow := IntfTable.Table[I]; {$R+}
                if (MibRow.dwType<>IF_TYPE_SOFTWARE_LOOPBACK) and
                     ( (MibRow.dwOperStatus=MIB_IF_OPER_STATUS_CONNECTED  ) or
                       (MibRow.dwOperStatus=MIB_IF_OPER_STATUS_OPERATIONAL)    )
                then begin

                    adapterdescr:='';
                    j:=0;
                    while MibRow.bDescr[j]<>0 do
                    begin
                      adapterdescr:=adapterdescr+Chr(MibRow.bDescr[j]);
                      Inc(j);
                    end;
                    adapterdescr:=Trim(adapterdescr);

                    // for some reason in vista the interfaces are listed twice
                    bAdded:=FALSE;
                    AdpIdx:=0;
                    for J := 0 to FormOptions.Adapter.Items.Count - 1 do
                    begin
                      if TIfObj(FormOptions.Adapter.Items.Objects[J]).Descr=adapterdescr then
                      begin
                        AdpIdx:=j;
                        bAdded:=TRUE;
                        break;
                      end;
                    end;

                    if (bAdded) then
                    begin
                        // only non-loopback-interfaces
                        CurrIfObj := TIfObj(FormOptions.Adapter.Items.Objects[AdpIdx]);
                        //k:=High(CurrIfObj.SArr)+1;
                        if CurrIfObj<>nil then
                        begin
                            if Screen.Width+10<>High(CurrIfObj.SArr)+1 then
                                SetLength(CurrIfObj.SArr,Screen.Width+10);

                            if globalx = 0 then begin
                                // first time set to current values
                                CurrIfObj.Last.DLOct:=MibRow.dwInOctets;
                                CurrIfObj.Last.ULOct:=MibRow.dwOutOctets;
                                WSessDL := WSessDL + MibRow.dwInOctets;
                                WSessUL := WSessUL + MibRow.dwOutOctets;
                            end;

                            // calc current speed and remember current DU-bytes
                            if SpeedCounter>=Screen.Width then begin
                              if MibRow.dwInOctets>CurrIfObj.Last.DLOct then
                              CurrIfObj.SArr[             0].DLSpeed := trunc((MibRow.dwInOctets  - CurrIfObj.Last.DLOct) / (Timer1.Interval/1000.0))
                              else
                              CurrIfObj.SArr[             0].DLSpeed := trunc((CurrIfObj.Last.DLOct  - MibRow.dwInOctets) / (Timer1.Interval/1000.0));
                              if MibRow.dwOutOctets>CurrIfObj.Last.ULOct then
                              CurrIfObj.SArr[             0].ULSpeed := trunc((MibRow.dwOutOctets - CurrIfObj.Last.ULOct) / (Timer1.Interval/1000.0))
                              else
                              CurrIfObj.SArr[             0].ULSpeed := trunc((CurrIfObj.Last.ULOct - MibRow.dwOutOctets) / (Timer1.Interval/1000.0));
                            end else begin
                              if MibRow.dwInOctets>CurrIfObj.Last.DLOct then
                              CurrIfObj.SArr[SpeedCounter+1].DLSpeed := trunc((MibRow.dwInOctets  - CurrIfObj.Last.DLOct) / (Timer1.Interval/1000.0))
                              else
                              CurrIfObj.SArr[SpeedCounter+1].DLSpeed := trunc((CurrIfObj.Last.DLOct  - MibRow.dwInOctets) / (Timer1.Interval/1000.0));
                              if MibRow.dwOutOctets>CurrIfObj.Last.ULOct then
                              CurrIfObj.SArr[SpeedCounter+1].ULSpeed := trunc((MibRow.dwOutOctets - CurrIfObj.Last.ULOct) / (Timer1.Interval/1000.0))
                              else
                              CurrIfObj.SArr[SpeedCounter+1].ULSpeed := trunc((CurrIfObj.Last.ULOct - MibRow.dwOutOctets) / (Timer1.Interval/1000.0));
                            end;

                            CurrIfObj.Last.DLOct := MibRow.dwInOctets;
                            CurrIfObj.Last.ULOct := MibRow.dwOutOctets;
                        end;

                        InOct  := InOct  + MibRow.dwInOctets;
                        OutOct := OutOct + MibRow.dwOutOctets;
                    end;
                end;
            end; // for all interfaces

            //k:=High(CurrIfObj.SArr)+1;
            CurrIfObj := TIfObj(FormOptions.Adapter.Items.Objects[0]);
            if (CurrIfObj<>nil) and (timediffcurr>0) then begin
                if Screen.Width+10<>High(CurrIfObj.SArr)+1 then
                    SetLength(CurrIfObj.SArr,Screen.Width+10)
                else
                    varinfo(80, 'nil');
                if globalx = 0 then begin
                    // first time - set to current values
                    CurrIfObj.Last.DLOct := InOct;
                    CurrIfObj.Last.ULOct := OutOct;
                end;

                (*
                varinfo(20, 'inoct: ' + inttostr(InOct));
                varinfo(40, 'DLoct: ' + inttostr(CurrIfObj.Last.DLOct));
                varinfo(60, 'timediff: ' + inttostr(timediffcurr));
                BitBlt(Form1.Canvas.Handle,0,0,Form1.ClientWidth,Form1.ClientHeight,
                       CanvasToDraw.Handle,0,0,SRCCOPY);
                *)

                if SpeedCounter>=Screen.Width then begin
                  CurrIfObj.SArr[             0].DLSpeed := (InOct  - CurrIfObj.Last.DLOct);
                  CurrIfObj.SArr[             0].ULSpeed := (OutOct - CurrIfObj.Last.ULOct);
                end else begin
                  if InOct>CurrIfObj.Last.DLOct then
                  CurrIfObj.SArr[SpeedCounter+1].DLSpeed := (InOct  - CurrIfObj.Last.DLOct )
                  else
                  CurrIfObj.SArr[SpeedCounter+1].DLSpeed := (CurrIfObj.Last.DLOct  - InOct );

                  if OutOct>CurrIfObj.Last.ULOct then
                  CurrIfObj.SArr[SpeedCounter+1].ULSpeed := (OutOct - CurrIfObj.Last.ULOct )
                  else
                  CurrIfObj.SArr[SpeedCounter+1].ULSpeed := (CurrIfObj.Last.ULOct  - OutOct);
                end;
                CurrIfObj.Last.DLOct := InOct;
                CurrIfObj.Last.ULOct := OutOct;
            end;

            if globalx = 1 then begin
                // not the first time
                Inc(SpeedCounter);
                if (SpeedCounter > Screen.Width) then begin
                  SpeedCounter:=0;
                  bfull:=TRUE;
                end;

                if InOct>WSessDL then
                WSessDLCurr:=InOct - WSessDL
                else
                WSessDLCurr:=WSessDL-InOct;

                if OutOct>WSessUL then
                WSessULCurr:=OutOct- WSessUL
                else
                WSessULCurr:=WSessUL-OutOct;

                if (IsWindowVisible(FormOptions.Handle)) then begin
                    (**-)
                    GetTcpStatistics(mitcpstats);
                    FormOptions. :=IntToStr(mitcpstats.dwNumConns)+' connections';
                    k:=mitcpstats.dwNumConns;
                    GetIpStatistics(miipstats);
                    GetIcmpStatistics(miicmp);
                    miicmp.stats.icmpInStats.dwMsgs;
                    GetUdpStatistics(miudpstats);
                    (**)

                    FormOptions.lbWindowsSession.Caption:='Windows Session:  ' +
                                    IntToSize(WSessDL)+' down - ' +
                                    IntToSize(WSessUL)+' up ';
                    FormOptions.lbTotal.Caption :='Total Monitored:  '   +
                                    IntToSize(TotDL+WSessDLCurr)+' down - ' +
                                    IntToSize(TotUL+WSessULCurr)+' up ';
                    FormOptions.lbSession.Caption:='Monitored Session:  ' +
                                    IntToSize(WSessDLCurr)+' down - ' +
                                    IntToSize(WSessULCurr)+' up ';
                end;
            end;

        end; // if IntfTable^.dwNumEntries>0 then
    end; // NO_ERROR
  finally
      FreeMem(IntfTable);
      globalx := 1;
      globalz := globalz + 2;
  end;
end;

procedure TForm1.clicktimerTimer(Sender: TObject);
begin
    if (clicktimer.tag=1) then begin
        FormOptions.Visible := True;
        SetForegroundWindow(FormOptions.Handle);
        FormOptions.SetFocus;
    end else begin
        if not doubleclicked then
            ToggleHide;
    end;
    clicktimer.tag:=-1;
    clicktimer.Enabled:=false;
    doubleclicked:=false;
end;

procedure TForm1.TimerWindowTimer(Sender: TObject);
var pos   : TPoint;
    wndPos: TRect;
begin
    if displaypopup.Tag=666 then exit;
    GetCursorPos(pos);
    GetWindowRect(form1.Handle, &wndPos);
    if PtInRect(wndPos,pos) then
    begin
      form1.Visible:=false;
    end else begin
      form1.Visible:=true;
      DrawGraph;
    end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if (displaypopup=nil) or (displaypopup.tag=666) then exit;
  UpdateInterfaces;
  DrawGraph;
  if (displaypopup=nil) or (displaypopup.tag=666) then exit;
  if bOnTop and (not FormOptions.Visible) and (Form1.Visible) then
  SetWindowPos(form1.Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE);
  //if FormOptions.Visible then
  //  FormOptions.SetFocus;
end;

procedure TForm1.TimerCounterTimer(Sender: TObject);
begin
  //TimerCounter
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
    px:=-1; py:=-1;
    if FormOptions<>nil then
      FormOptions.GetAdapters;
    (**-)
    //SetFormStyleExternal;
    if bOnTop then begin
    SetWindowPos(form1.Handle,HWND_TOPMOST, 0,0,0,0,
                 SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED)
    end else
    SetWindowPos(form1.Handle,HWND_NOTOPMOST, 0,0,0,0,
                 SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED)
    (**)
end;

//
(*
2
5
10
25
50
100
250
*)

end.

