unit properties;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, ShellAPI, Spin, Strutils,
  Winsock,
  IdHTTP,
  IpRtrMib, IpHlpApi, IpIfConst;

type
  TFormOptions = class(TForm)
    GroupBox1: TGroupBox;
    btPresetNice: TButton;
    btPresetDefault: TButton;
    btPresetGhost: TButton;
    AverageDistance: TComboBox;
    UpdateInterval: TComboBox;
    Label7: TLabel;
    ColorDialog: TColorDialog;
    PanelBG: TPanel;
    PanelDL: TPanel;
    PanelDLAvg: TPanel;
    PanelUL: TPanel;
    PanelULAvg: TPanel;
    HideCaption: TCheckBox;
    cbDL: TCheckBox;
    cbUL: TCheckBox;
    cbDLAvg: TCheckBox;
    cbULAvg: TCheckBox;
    filledgraph: TCheckBox;
    Adapter: TComboBox;
    PanelBorder: TPanel;
    cbBorderLines: TCheckBox;
    PanelFont: TPanel;
    GroupBox2: TGroupBox;
    cbFont: TCheckBox;
    cbBG: TCheckBox;
    AlwaysOnTop: TCheckBox;
    cbClickThrough: TCheckBox;
    Label1: TLabel;
    GridUnit: TComboBox;
    Button5: TButton;
    Label3: TLabel;
    PanelCombined: TPanel;
    Label4: TLabel;
    PanelShadow: TPanel;
    cbShadow: TCheckBox;
    LevelWidth: TSpinEdit;
    Label5: TLabel;
    cbAverage: TCheckBox;
    FontDlg: TFontDialog;
    cbfancy: TCheckBox;
    cbScaleEqually: TCheckBox;
    cbSeparate: TCheckBox;
    PanelSeparate: TPanel;
    cbValuesInColor: TCheckBox;
    Label8: TLabel;
    Label10: TLabel;
    lbIPAddress: TEdit;
    lbMACAddress: TEdit;
    GroupBox3: TGroupBox;
    FontName: TButton;
    FontSize: TSpinEdit;
    cbBold: TCheckBox;
    GroupBox4: TGroupBox;
    Label2: TLabel;
    tpCount: TTrackBar;
    lbTpCount: TLabel;
    GroupBox5: TGroupBox;
    mode1: TRadioButton;
    mode0: TRadioButton;
    mode2: TRadioButton;
    PanelGrid: TPanel;
    cbGridUnits: TCheckBox;
    Label9: TLabel;
    PixelWidth: TSpinEdit;
    LinkedWindow: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;

    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button6: TButton;
    Button7: TButton;
    Button4: TButton;
    CheckBox1: TCheckBox;
    lblExtIP: TEdit;
    Label14: TLabel;
    Button9: TButton;
    HideBorder: TCheckBox;
    ShowInAltTab: TCheckBox;
    ShowInTaskbar: TCheckBox;
    Label19: TLabel;
    lVersionInfo: TLabel;
    lbWindowsSession: TPanel;
    lbTotal: TPanel;
    lbSession: TPanel;
    HideOnMouseOver: TCheckBox;
    Button10: TButton;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);

    procedure btPresetDefaultClick(Sender: TObject);
    procedure btPresetGhostClick(Sender: TObject);
    procedure Label6DblClick(Sender: TObject);
    procedure FontNameClick(Sender: TObject);
    procedure btPresetNiceClick(Sender: TObject);

    procedure AdapterChange(Sender: TObject);
    procedure GetColor(Sender: TObject);
    procedure UpdateThisControl(Sender: TObject);
    procedure UpdateThisSpecialControl(Sender: TObject);
    procedure SetSettings(special: boolean);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Label19Click(Sender: TObject);
    procedure Label19MouseEnter(Sender: TObject);
    procedure Label19MouseLeave(Sender: TObject);
    procedure Button10Click(Sender: TObject);

  private
    { Private-Deklarationen }
    dontupdate: Boolean;
    function  GetState(state: TCheckBoxState): integer;
    function  GetDrawmode: integer;
    procedure SetDrawmode(mode: integer);
  public
    { Public-Deklarationen }
    lastip:string;
    procedure checkRealIP;
    function GetIPAddress(idx: integer):string;
    procedure UpdateAdapterInfo;
    procedure GetAdapters;
    procedure GetSettings;

  end;

  TIfDU  = record
    DLOct:Cardinal;
    ULOct:Cardinal;
  end;

  TIfSpeed  = record
    DLSpeed:Cardinal;
    ULSpeed:Cardinal;
  end;

  TIfObj = class(TObject)
    IP:string;
    Mac:string;
    Name: String;
    Descr: String;
    SArr: array of TIfSpeed;
    Last: TIfDU;
    Speed:Cardinal;
  end;
  PIfObj = ^TIfObj;

var FormOptions: TFormOptions;

implementation

{$R *.DFM}

uses main;

procedure TFormOptions.FormCreate(Sender: TObject);
begin
    GetAdapters;
    if Adapter.items.Count>Form1.AdapterItemIndex then
      Adapter.ItemIndex:=Form1.AdapterItemIndex
    else
      Adapter.ItemIndex:=0;

    AdapterChange(Sender);
    dontupdate:=true;
    GetSettings;
    dontupdate:=false;
    lVersionInfo.Caption:=VersionInfo;

    // only read customcolors once at start of the app
    ColorDialog.CustomColors.Add('ColorA='+IntToHex(ColorToRgb(PanelDL.Color      ),8));
    ColorDialog.CustomColors.Add('ColorB='+IntToHex(ColorToRgb(PanelDLAvg.Color   ),8));
    ColorDialog.CustomColors.Add('ColorC='+IntToHex(ColorToRgb(PanelUL.Color      ),8));
    ColorDialog.CustomColors.Add('ColorD='+IntToHex(ColorToRgb(PanelULAvg.Color   ),8));
    ColorDialog.CustomColors.Add('ColorE='+IntToHex(ColorToRgb(PanelCombined.Color),8));
    ColorDialog.CustomColors.Add('ColorF='+IntToHex(ColorToRgb(PanelBorder.Color  ),8));
    ColorDialog.CustomColors.Add('ColorM='+IntToHex(ColorToRgb(PanelGrid.Color    ),8));
    ColorDialog.CustomColors.Add('ColorG='+IntToHex(ColorToRgb(PanelBG.Color      ),8));
    ColorDialog.CustomColors.Add('ColorH='+IntToHex(ColorToRgb(PanelFont.Color    ),6));
    ColorDialog.CustomColors.Add('ColorI='+IntToHex(ColorToRgb(PanelSeparate.Color),8));
    ColorDialog.CustomColors.Add('ColorJ='+IntToHex(ColorToRgb(PanelShadow.Color  ),8));
    ColorDialog.CustomColors.Add('ColorK='+IntToHex(ColorToRgb(clBtnFace          ),8));
    ColorDialog.CustomColors.Add('ColorL='+IntToHex(ColorToRgb(clBackground       ),8));
    (*
    for i:= 0 to Listbox1.items.count-1 do
    begin
      //Opgelet: er mogen MAXIMUM 16 kleuren toegevoegd worden
      if i >= 16 then
           break;
      Colordialog1.CustomColors.add(format('Color%s=%s',[chr(i+65);listbox1.items[i]]));
    end;
    *)
end;

procedure TFormOptions.FormDestroy(Sender: TObject);
var I: Integer;
    IfObj:TIfObj;
begin
    for i := 0 to (Adapter.Items.Count - 1) do
    begin
      IfObj:=TIfObj(Adapter.Items.Objects[i]);
      IfObj.Free;
    end;
end;

procedure TFormOptions.FormHide(Sender: TObject);
var m: tagMSG;
    i: integer;
begin
  Form1.config_write;
end;

///////////////////////////////////////////////

procedure TFormOptions.checkRealIP;
var sx:string;
    i:integer;
    IdHTTP1:TIdHTTP;
begin
  SetCursor(LoadCursor(0, IDC_WAIT));
  //if (Form1.Timer1.Enabled) then exit;
  //iphlpapi GetBestRoute
  IdHTTP1:=TIdHTTP.Create(self);
  try
    sx:=IdHTTP1.Get('http://bot.whatismyipaddress.com/');
    IdHTTP1.Disconnect;

    if sx<>'' then
    begin
      i:=1;
      while sx[i] in ['0'..'9','.'] do
        inc(i);
      delete(sx,i,length(sx));
      lblExtIP.Text:=sx;
    end;

  finally
  //except on EIdHTTPProtocolException do
    ;
  end;

  IdHTTP1.Free;
  SetCursor(LoadCursor(0, IDC_ARROW));
end;

///////////////////////////////////////////////

function IntToIp(Ip: Cardinal): string;
type TIpRec = record n1, n2, n3, n4: Byte; end;
begin
  with TIpRec(Ip) do Result := Format('%d.%d.%d.%d', [n1, n2, n3, n4]);
end;

function GetMacAddress (VAR Addr) : String;
var daten : array[0..5] of byte absolute Addr;
begin
   Result := lowercase(Format('%2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x',[Daten[0],daten[1],Daten[2],Daten[3],Daten[4],Daten[5]]));
end;

function TFormOptions.GetIPAddress(idx: integer):string;
var Size: Cardinal;
    IpAddrTable: PMib_IpAddrTable;
    i: integer;
begin
  Size := 0;
  result:='---';
  GetIpAddrTable(nil, Size, True);
  if Size > 0 then
  begin
    GetMem(IpAddrTable, Size);
    try
      if GetIpAddrTable(IpAddrTable, Size, True) = ERROR_SUCCESS  then
        for i := 0 to IpAddrTable^.dwNumEntries -1  do
           if (idx = IpAddrTable^.table[i].dwIndex) then
               result:=IntToIp(IpAddrTable^.table[i].dwAddr);
    finally
      FreeMem(IpAddrTable);
    end;
  end;
end;

procedure TFormOptions.UpdateAdapterInfo;
var MibRow: TMibIfRow;
    IntfTable: PMibIfTable;
    Size: DWORD;
    I: Integer;
    IfObj:TIfObj;
begin
  lbIPAddress.Text:='---';
  lbMACAddress.Text:='---';
  size := 0;
  IfObj:=TIfObj(Adapter.Items.Objects[adapter.ItemIndex]);

  //lbIPAddress.Text  := '288.288.288.288';
  //lbMACAddress.Text := lowercase('CC:CC:CC:CC:CC:CC');
  lbIPAddress.Text  := IfObj.IP;
  lbMACAddress.Text := IfObj.Mac;

  (*
  if GetIfTable(nil, Size, True) <> ERROR_INSUFFICIENT_BUFFER then Exit;
  IntfTable := AllocMem(Size);
  try
    if GetIfTable(IntfTable, Size, True) = NO_ERROR then
    begin
      for I := 0 to IntfTable^.dwNumEntries - 1 do
      begin
        if form1.AdapterItemIndex=i+1 then begin
          {$R-}MibRow := IntfTable.Table[I];{$R+}
          lbIPAddress.Text  := GetIPAddress(MibRow.dwIndex);
          lbMACAddress.Text := GetMacAddress     (MibRow.bPhysAddr);
          lblDescr.caption:=Adapter.de
        end;
      end;
    end;
  finally
    FreeMem(IntfTable);
  end;
  *)
end;

///////////////////////////////////////////////

procedure TFormOptions.GetAdapters;
var MibRow: TMibIfRow;
    IntfTable: PMibIfTable;
    Size: DWORD;
    bAdded:boolean;
    I, J: Integer;
    IfObj:TIfObj;
    ifIdx:Integer;
    adaptername,adapterdescr:string;
    s,sIP,sMAC:string;
begin
  size := 0;

  ifIdx:=Adapter.Items.IndexOf('All Network-Adapters');
  if ifIdx<0 then
  begin
    ifIdx:=Adapter.Items.Add('All Network-Adapters');
    IfObj:=TIfObj.Create;
    IfObj.IP :='---';
    IfObj.Mac:='---';
    IfObj.Name:='';
    IfObj.Descr:='';
    Adapter.Items.Objects[ifIdx]:=IfObj;
  end;
  SetLength(TIFObj(Adapter.Items.Objects[ifIdx]).SArr, Screen.Width+10);
  //SetLength(IfObj.SArr, Screen.Width+10);

  // get IntfTable-size
  if GetIfTable(nil, Size, True) <> ERROR_INSUFFICIENT_BUFFER then Exit;
  // alloc mem for IntfTable
  IntfTable := AllocMem(Size);
  try
    // get IntfTable-data
    if GetIfTable(IntfTable, Size, True) = NO_ERROR then begin
      // loop all interfaces and get their data
      for I := 0 to IntfTable^.dwNumEntries - 1 do
      begin
          {$R-} MibRow := IntfTable.Table[I]; {$R+}
          adaptername:=PChar(@MibRow.wszName[0]);
          adapterdescr:='';
          j:=0;
          while MibRow.bDescr[j]<>0 do
          begin
            adapterdescr:=adapterdescr+Chr(MibRow.bDescr[j]);
            Inc(j);
          end;
          adapterdescr:=Trim(adapterdescr);
          adaptername:=Trim(adaptername);

          bAdded:=false;
          for j:=0 to Adapter.Items.Count-1 do begin
            IfObj:=TIFObj(Adapter.Items.Objects[j]);
            if ((IfObj.Name<>'' ) and (IfObj.Name=adaptername)) or
               ((IfObj.Descr<>'') and
               ((IfObj.Descr=adapterdescr) or (PosEx(IfObj.Descr,adapterdescr)>0))

               )
               //(IfObj.Mac=GetMacAddress(MibRow.bPhysAddr))
            then begin
              bAdded:=true;
              break;
            end;

          end;

          if (not bAdded)
             //and (MibRow.dwType<>IF_TYPE_SOFTWARE_LOOPBACK)
             //and (MibRow. dwType<>MIB_IF_TYPE_LOOPBACK) then //  < IF_TYPE_PROP_POINT2POINT_SERIAL) then
          then begin
            //ifIdx:=Adapter.Items.Add(adapterdescr);
            //
            //IfObj:=TIFObj(Adapter.Items.Objects[ifIdx]);
            //SetLength(TIFObj(Adapter.Items.Objects[ifIdx]).SArr, Screen.Width+10);

            sIP := GetIPAddress (MibRow.dwIndex);
            sMAC:= GetMacAddress(MibRow.bPhysAddr);

            if (sIP<>'0.0.0.0') and
               (sMAC<>'00:00:00:00:00:00') and
               (sIP<>'---') and (sMAC<>'---')
            then begin
                IfObj:=TIfObj.Create;
                IfObj.IP := sIP;
                IfObj.Mac:= sMAC;
                IfObj.Name:=adaptername;
                IfObj.Descr:=adapterdescr;
                IfObj.Speed:=MibRow.dwSpeed;

                SetLength(IfObj.SArr, Screen.Width+10);
                //Adapter.Items.Objects[ifIdx]:=IfObj;
                Adapter.Items.Objects[Adapter.Items.Add(IfObj.Descr)]:=IfObj;
            end;
          end;
      end;
      //form1.lastInOct  := form1.lastInOct  + MibRow.dwInOctets;
      //form1.lastOutOct := form1.lastOutOct + MibRow.dwOutOctets;
    end;
  finally
    FreeMem(IntfTable);
  end;
end;

procedure TFormOptions.AdapterChange(Sender: TObject);
begin
  Form1.timer1.Enabled := false;
  Form1.AdapterItemIndex := Adapter.ItemIndex;
  globalx := 0;
  globalz := 0;
  globaln := 0;
  UpdateAdapterInfo;
  Form1.timer1.Enabled := true;
  Adapter.Hint:=
    TIFObj(Adapter.Items.Objects[Adapter.itemindex]).Descr+
    #13+#10+
    TIFObj(Adapter.Items.Objects[Adapter.itemindex]).IP+
    #13+#10+
    TIFObj(Adapter.Items.Objects[Adapter.itemindex]).Mac+
    #13+#10+
    TIFObj(Adapter.Items.Objects[Adapter.itemindex]).Name;
  if Form1.SpeedCounter>0 then
    Form1.DrawGraph;
end;

procedure TFormOptions.Button3Click(Sender: TObject);
begin
  //TotDL:=TotDL+WSessDLCurr;
  //TotUL:=TotUL+WSessULCurr;
  GetAdapters;
  Adapter.ItemIndex:=Form1.AdapterItemIndex;
  AdapterChange(Sender);
end;

procedure TFormOptions.Button9Click(Sender: TObject);
begin
  CheckRealIP;
end;

procedure TFormOptions.Button10Click(Sender: TObject);
begin
  Form1.SessDL:=0;
  Form1.SessUL:=0;
end;

procedure TFormOptions.Button1Click(Sender: TObject);
begin
  Hide;
end;

procedure TFormOptions.Button5Click(Sender: TObject);
begin
  close;
  Form1.Close;
end;

procedure TFormOptions.GetColor(Sender: TObject);
var Panel: TPanel;
begin
  Panel:=TPanel(Sender);
  ColorDialog.Color := Panel.Color;
  ColorDialog.Options := [cdFullOpen];
  if not ColorDialog.Execute then Exit;
  Panel.Color := ColorDialog.Color;
  SetSettings(sender=PanelBG);
  if visible then SetFocus;
end;

procedure TFormOptions.UpdateThisControl(Sender: TObject);
begin
  SetSettings(false);
end;

procedure TFormOptions.UpdateThisSpecialControl(Sender: TObject);
begin
  SetSettings(true);
end;

procedure TFormOptions.Button4Click(Sender: TObject);
begin
  form1.ToggleHide;
  button4.caption:=form1.displaypopup.Items[6].Caption;
end;

procedure TFormOptions.Label6DblClick(Sender: TObject);
begin
  Form1.DeletePeaks;
end;

procedure TFormOptions.Button7Click(Sender: TObject);
begin
  Form1.mPeakClick(Sender);
end;

procedure TFormOptions.CheckBox1Click(Sender: TObject);
begin
  if dontupdate then exit;
  Application.ProcessMessages;
  if CheckBox1.Checked then CanvasToDraw:=Form1.Canvas   // for debug
                       else CanvasToDraw:=form1.Display.Canvas; // for real
end;

procedure TFormOptions.Button6Click(Sender: TObject);
begin
  Form1.mResetGraphClick(Sender);
end;

procedure TFormOptions.FontNameClick(Sender: TObject);
begin
  FontDlg.Font.Name:=FontName.Font.Name;
  FontDlg.Font.Size:=FontSize.Value;
  if cbBold.Checked then FontDlg.Font.Style:=[fsBold]
                    else FontDlg.Font.Style:=[];
  FontDlg.Options:=[fdTrueTypeOnly,fdNoSimulations,fdForceFontExist,fdScalableOnly];
  if FontDlg.Execute then begin
      FontName.Font.Name:=FontDlg.Font.Name;
      FontSize.Value:=FontDlg.Font.Size;
      FontName.Caption:=FontName.Font.Name;
      if (fsBold in FontDlg.Font.Style) then cbBold.Checked:=True
                                        else cbBold.Checked:=false;
      UpdateThisControl(Sender);
  end;
end;

function TFormOptions.GetState(state: TCheckBoxState): integer;
begin
  result:=0;
  if      state=cbUnChecked then result:=0
  else if state=cbChecked   then result:=1
  else if state=cbGrayed    then result:=2;
end;

procedure TFormOptions.btPresetGhostClick(Sender: TObject);
begin
  dontupdate:=true;
  if btPresetGhost.caption='&Ghost' then begin
    cbClickThrough.Checked:=TRUE;
    cbBG.Checked:=false;
    AlwaysOnTop.Checked:=true;
    HideCaption.Checked:=true;
    HideBorder.Checked:=true;
    btPresetGhost.caption:='Un&ghost';
    dontupdate:=false;
    SetSettings(true);
  end else begin
    cbClickThrough.Checked:=false;
    cbBG.Checked:=true;
    btPresetGhost.caption:='&Ghost';
    dontupdate:=false;
    tpCount.Position:=0;
    SetSettings(true);
  end;
end;

procedure TFormOptions.btPresetNiceClick(Sender: TObject);
begin
    dontupdate:=true;

    AverageDistance.ItemIndex:=0;
    tpCount.Position:=50;

    filledgraph.Checked:=TRUE;
    cbDL.Checked:=TRUE;
    cbUL.Checked:=TRUE;
    cbDLAvg.Checked:=TRUE;
    cbULAvg.Checked:=TRUE;
    cbBG.Checked:=False;
    cbShadow.Checked:=True;
    cbValuesInColor.Checked:=true;
    PixelWidth.Value:=2;
	  LevelWidth.Value:=8;

    cbAverage.Checked:=True;
    cbFancy.Checked:=True;
    cbSeparate.Checked:=false;
    cbScaleEqually.Checked:=false;

    cbGridUnits.Checked:=FALSE;
    cbBorderLines.Checked:=TRUE;
    cbFont.State:=cbChecked;
    HideCaption.Checked:=true;
    cbShadow.State:=cbChecked;

    dontupdate:=false;
    SetSettings(true);
end;

procedure TFormOptions.Button2Click(Sender: TObject);
begin
    dontupdate:=true;

    AverageDistance.ItemIndex:=0;
    tpCount.Position:=50;

    filledgraph.Checked:=TRUE;
    cbDL.Checked:=TRUE;
    cbUL.Checked:=TRUE;
    cbDLAvg.Checked:=TRUE;
    cbULAvg.Checked:=TRUE;
    cbBG.Checked:=False;
    cbShadow.Checked:=True;
    cbValuesInColor.Checked:=true;
    PixelWidth.Value:=2;
    LevelWidth.Value:=8;

    cbAverage.Checked:=True;
    cbFancy.Checked:=True;
    cbSeparate.Checked:=false;
    cbScaleEqually.Checked:=false;

    cbBorderLines.Checked:=FALSE;
    cbGridUnits.Checked:=FALSE;
    cbFont.State:=cbGrayed;
    HideCaption.Checked:=true;
    cbShadow.State:=cbChecked;

    dontupdate:=false;
    SetSettings(true);
end;

procedure TFormOptions.btPresetDefaultClick(Sender: TObject);
begin
    dontupdate:=true;

    PanelBG.Color:=$303030;
    PanelBorder.Color:=$c0c0c0;
    PanelFont.Color:=$ffffff;
    PanelShadow.Color:=$000000;
    PanelCombined.Color:=clYellow;
    PanelDL.Color:=clGreen;
    PanelDLAvg.Color:=clLime;
    PanelUL.Color:=clMaroon;
    PanelULAvg.Color:=clRed;
    PanelSeparate.Color:=clBlack;

    AverageDistance.ItemIndex:=0;
    tpCount.Position:=30;

    cbClickThrough.Checked:=FALSE;
    filledgraph.Checked:=TRUE;
    cbDL.Checked:=TRUE;
    cbUL.Checked:=TRUE;
    cbDLAvg.Checked:=TRUE;
    cbULAvg.Checked:=TRUE;
    cbBold.Checked:=FALSE;
    cbBG.Checked:=True;
    AlwaysOnTop.Checked:=TRUE;
    cbShadow.Checked:=True;
    cbValuesInColor.Checked:=TRUE;
    btPresetGhost.caption:='&Ghost';
    PixelWidth.Value:=1;
    LevelWidth.Value:=0;
    FontSize.Value:=12;
    FontName.Caption:='Tahoma';
    FontName.Font.Name:='Tahoma';

    mode0.Checked:=false;
    mode2.Checked:=false;
    mode1.Checked:=true;
    cbAverage.Checked:=False;
    cbFancy.Checked:=False;
    cbSeparate.Checked:=TRUE;
    cbScaleEqually.Checked:=TRUE;

    cbBorderLines.Checked:=FALSE;
    cbGridUnits.Checked:=FALSE;
    cbFont.State:=cbChecked;
    HideCaption.Checked:=TRUE;
    cbShadow.State:=cbGrayed;

    dontupdate:=false;
    SetSettings(true);
end;

function TFormOptions.GetDrawmode: integer;
begin
    if mode0.checked then result:=0 else
    if mode2.checked then result:=2 else
    result:=1;
end;

procedure TFormOptions.SetDrawmode(mode: integer);
begin
    if mode=0 then mode0.checked:=true else
    if mode=2 then mode2.checked:=true else
    mode1.checked:=true;
end;

procedure TFormOptions.SetSettings(special:boolean);
begin
    if dontupdate then exit;
    HideBorder.Enabled:=not cbClickThrough.Checked;
    form1.ColBG:=PanelBG.Color;
    form1.ColComb:=PanelCombined.Color;
    form1.ColBorder:=PanelBorder.Color;
    form1.ColGrid:=PanelGrid.Color;
    form1.ColFont:=PanelFont.Color;
    form1.ColDL:=PanelDL.Color;
    form1.ColDLAvg:=PanelDLAvg.Color;
    form1.ColUL:=PanelUL.Color;
    form1.ColULAvg:=PanelULAvg.Color;
    form1.ColShadow:=PanelShadow.Color;
    form1.ColSeparate:=PanelSeparate.Color;

    //UpdateInterval.ItemIndex:=0;
    form1.Timer1.Interval:=StrToInt(UpdateInterval.Text);
    form1.avg_value:=StrToInt(AverageDistance.Text);
    form1.gridunit:=StrToInt(gridunit.Text);

    form1.bDL:=cbDL.Checked;
    form1.bDLAvg:=cbDLAvg.Checked;
    form1.bUL:=cbUL.Checked;
    form1.bULAvg:=cbULAvg.Checked;
    form1.bBold:=cbBold.Checked;
    form1.bBG:=cbBG.Checked;
    form1.bSeparate:=cbSeparate.Checked;

    form1.bfilledgraph:=filledgraph.Checked;
    form1.bScaleEqually:=cbScaleEqually.Checked;
    form1.bValuesInColor:=cbValuesInColor.Checked;
    form1.bAverage:=cbAverage.Checked;

    form1.bOnTop:=AlwaysOnTop.Checked;
    form1.bClickThrough:=cbClickThrough.Checked;
    form1.bHideonMouseOver:=HideonMouseOver.Checked;

    form1.drawmode:=GetDrawmode;

    form1.PixelWidth:=PixelWidth.Value;
    form1.Levelwidth:=Levelwidth.Value;
    form1.FontSize:=FontSize.Value;
    form1.FontName:=FontName.Font.Name;
    form1.LinkedWindow:=LinkedWindow.Text;

    form1.bGridunits:=cbGridUnits.Checked;
    form1.iBorderLines:=GetState(cbBorderLines.state);
    form1.bHideCaption:=HideCaption.Checked;
    form1.bHideBorder:=HideBorder.Checked;
    form1.bShowInaltTab:=ShowInaltTab.Checked;
    form1.bShowInTaskbar:=ShowInTaskbar.Checked;

    form1.ShadowMode:=GetState(cbShadow.State);
    form1.iFancyState:=GetState(cbfancy.State);
    form1.iFontState:=GetState(cbFont.State);

    Label1.Enabled:=cbGridUnits.Checked;
    GridUnit.Enabled:=cbGridUnits.Checked;

    if mode1.checked then begin
      cbScaleEqually.Enabled:=false;
      label4.Enabled:=true;
    end else begin
      cbScaleEqually.Enabled:=true;
      label4.Enabled:=false
    end;

    form1.mIgnoreMouse.Checked:=cbClickThrough.Checked;
    form1.mAlwaysonTop.Checked:=AlwaysOnTop.Checked;
    form1.mHideonMouseOver.Checked:=HideonMouseOver.Checked;
    form1.TimerWindow.Enabled:=HideonMouseOver.Checked;

    form1.tpCount:=tpCount.Position;
    lbTpCount.Caption:=IntToStr(tpCount.Position)+'%';

    if cbClickThrough.Checked then begin
      tpCount.SelStart:=20;
      tpCount.SelEnd:=100;
    end else begin
      tpCount.SelStart:=0;
      tpCount.SelEnd:=100;
    end;

    if cbClickThrough.Checked and (tpCount.Position<20) then
      tpCount.Position:=20;

    form1.AlphaBlendValue := Trunc( (100-form1.tpCount)/100*255 );
    if Form1.AlphaBlendValue<255 then Form1.AlphaBlend:=TRUE
                                 else Form1.AlphaBlend:=FALSE;

    if special then Form1.SetFormStyle;
    form1.MakeShadedPalettes;
    form1.DrawGraph;
    if visible then SetFocus;
end;

procedure TFormOptions.GetSettings;
var i: integer;
begin
    dontupdate:=TRUE;
    if CanvasToDraw<>Form1.Canvas then CheckBox1.Checked:=false
                                  else CheckBox1.Checked:=true;

    PanelBG.Color:=form1.ColBG;
    PanelCombined.Color:=form1.ColComb;
    PanelBorder.Color:=form1.ColBorder;
    PanelGrid.Color:=form1.ColGrid;
    PanelDL.Color:=form1.ColDL;
    PanelDLAvg.Color:=form1.ColDLAvg;
    PanelUL.Color:=form1.ColUL;
    PanelULAvg.Color:=form1.ColULAvg;
    PanelFont.Color:=form1.ColFont;
    PanelShadow.Color:=form1.ColShadow;
    PanelSeparate.Color:=form1.ColSeparate;

    cbBG.Checked:=form1.bBG;
    cbBold.Checked:=form1.bBold;
    cbDL.Checked:=form1.bDL;
    cbDLAvg.Checked:=form1.bDLAvg;
    cbUL.Checked:=form1.bUL;
    cbULAvg.Checked:=form1.bULAvg;
    cbSeparate.Checked:=form1.bSeparate;

    AlwaysOnTop.Checked:=form1.bOnTop;
    cbClickThrough.Checked:=form1.bClickThrough;
    HideonMouseOver.Checked:=form1.bHideOnMouseOver; //mHideonMouseOver.Checked:=;

    cbValuesInColor.Checked:=form1.bValuesInColor;
    filledgraph.Checked:=form1.bFilledGraph;
    cbScaleEqually.Checked:=form1.bScaleEqually;
    cbAverage.Checked:=form1.bAverage;

    cbGridUnits.Checked:=form1.bGridunits;
    cbBorderLines.state:=TCHeckboxstate(form1.iBorderLines);
    cbFont.State:=TCheckBoxState(form1.iFontState);
    cbShadow.State:=TCheckBoxState(form1.ShadowMode);
    HideCaption.Checked:=Form1.bHideCaption;
    HideBorder.Checked:=Form1.bHideBorder;
    ShowInAltTab.Checked:=form1.bShowInaltTab;
    ShowInTaskbar.Checked:=form1.bShowInTaskbar;

    cbfancy.State:=TCheckBoxState(Form1.iFancyState);
    //DrawMode.ItemIndex:=Form1.drawmode;
    SetDrawMode(Form1.drawmode);

    FontSize.Value:=form1.FontSize;
    FontName.Font.Name:=form1.FontName;
    FontName.Caption:=form1.FontName;
    linkedwindow.Text:=form1.LinkedWindow;
    lbTpCount.Caption:=IntToStr(tpCount.Position)+'%';
    tpCount.Position:=form1.tpCount;

    if cbClickThrough.Checked then begin
      tpCount.SelStart:=20;
      tpCount.SelEnd:=100;
    end else begin
      tpCount.SelStart:=0;
      tpCount.SelEnd:=100;
    end;
    HideBorder.Enabled:=not cbClickThrough.Checked;

    Levelwidth.Value:=form1.LevelWidth;
    PixelWidth.Value:=form1.PixelWidth;
    Label1.Enabled:=cbGridUnits.Checked;
    GridUnit.Enabled:=cbGridUnits.Checked;

    for i:=0 to UpdateInterval.Items.Count-1 do
        if IntToStr(form1.Timer1.Interval)=UpdateInterval.Items[i] then
            UpdateInterval.ItemIndex:=i;
    for i:=0 to AverageDistance.Items.Count-1 do
        if IntToStr(form1.avg_value)=AverageDistance.Items[i] then
            AverageDistance.ItemIndex:=i;
    for i:=0 to gridunit.Items.Count-1 do
        if IntToStr(form1.gridunit)=gridunit.Items[i] then
            gridunit.ItemIndex:=i;

    if mode1.Checked then begin
      cbScaleEqually.Enabled:=false;
      label4.Enabled:=true;
    end else begin
      cbScaleEqually.Enabled:=true;
      label4.Enabled:=false
    end;

    dontupdate:=false;
end;

procedure TFormOptions.FormShow(Sender: TObject);
begin
  dontupdate:=true;
  lblExtIP.Text:='---';
  GetSettings;
  dontupdate:=false;
  cbClickThrough.Checked;
  //DrawPalette;
end;

procedure TFormOptions.Label19Click(Sender: TObject);
begin
  ShellExecute(Handle,'open','http://blumetools.dd-dns.de/','','',1);
end;

procedure TFormOptions.Label19MouseEnter(Sender: TObject);
begin
  Label19.font.Style:=[];
end;

procedure TFormOptions.Label19MouseLeave(Sender: TObject);
begin
  Label19.font.Style:=[fsUnderline];
end;

end.
